<%@
      page language="java" contentType="text/html; charset=UTF-8"
%><%@ page import = "org.jdom.Element,
					 com.oberon.client.Application,
					 com.oberon.client.ApplicationRequest,
					 com.oberon.ooql.sdk.*,
					 com.oberon.client.TAGS,
					 com.oberon.ooql.sdk.Dictionary,
					 com.oberon.ooql.sdk.Class,
					 com.oberon.util.*,
                     java.lang.*,
                     java.util.*,
                     java.io.*,
                     java.text.*,
					 java.net.URLEncoder"
%><%!
   static public final String menu_files_path = "common/menu_files";
   static public final boolean useNiceForms = true;
   
   static public Hashtable<String,String> applicationParameters  = null;
   static public String dictSection = "";
   static public String applicationPath= "";
   static public String application_main_menu;
   static public String anonymous_user_name;
   static public String anonymous_user_password;
   static public String name_revision_separator;
   static public boolean use_browser_language;
     
   
   static public ApplicationRequest convertRequest(HttpServletRequest request) {
  	 ApplicationRequest apprequest = new ApplicationRequest(request.getRequestURL().toString(),request.getSession());
	 StringBuffer valueP = null;
	 for (Enumeration<?> en = request.getParameterNames(); en.hasMoreElements();) {
		String nameP =  (String)en.nextElement();		
		String[] valueMulti = request.getParameterValues(nameP);
		valueP = new StringBuffer("");
		for (int i = 0; i < valueMulti.length; i++) {
			if (i > 0) { valueP.append(Field.ATTRSEP); }
			valueP.append(valueMulti[i]);
		}
		apprequest.setParameter(nameP, valueP.toString());
	 }
  	 for (Enumeration<?> en=request.getAttributeNames();en.hasMoreElements();) {
  		String sKey = (String)en.nextElement();
  		apprequest.setAttribute(sKey, request.getAttribute(sKey));    		
   	 }
  	 apprequest.setLocale(request.getLocale());	 
  	 return apprequest;
   }

   // 
   static public void loadApplicationParameters(HttpSession session)  {
	  if ( applicationParameters==null && application_main_menu.length()>0 ) {	  	 
	     applicationParameters=new Hashtable<String,String>();
		 try {  
			 Framework framework = Application.getFramework(session);
			 Menu mainmenu = Menu.open(application_main_menu,framework,null);
			 Vector<Feature> vFeatures=mainmenu.getFeatures(framework);
			 if (vFeatures!=null) {
				 int iSize = vFeatures.size();
				 for (int i=0;i<iSize;i++) {
				   Feature feature=vFeatures.elementAt(i);
				   if ( feature.getTo().equals("") ) {
					 String sFeature = feature.getName(); 
					 applicationParameters.put(sFeature,feature.getValue());
					 if ( sFeature.equals(TAGS.APP_dictionary_menu_section)) Application.getApp().dictionary_menu_section=feature.getValue();
					 else if ( sFeature.equals(TAGS.APP_dictionary_common_section)) Application.getApp().dictionary_common_section=feature.getValue();
					 else if ( sFeature.equals(TAGS.APP_dictionary_section)) Application.getApp().dictionary_section=feature.getValue();		
					 else if ( sFeature.equals(TAGS.APP_dictionary_default_language)) Application.getApp().dictionary_default_language=feature.getValue();
					 else if ( sFeature.equals(TAGS.APP_show_object_class)) Application.getApp().show_object_class=feature.getValue().equals("true");
					 else if ( sFeature.equals(TAGS.APP_show_object_namerev)) Application.getApp().show_object_namerev=feature.getValue().equals("true");
					 else if ( sFeature.equals(TAGS.APP_use_search_patterns)) Application.getApp().use_search_patterns=feature.getValue().equals("true");
					 else if ( sFeature.equals(TAGS.APP_number_separator_symbols)) Application.getApp().number_separator_symbols=feature.getValue();
					 else if ( sFeature.equals(TAGS.APP_name_revision_separator)) Application.getApp().name_revision_separator=feature.getValue();
					 else if ( sFeature.equals(TAGS.APP_search_all_label)) Application.getApp().search_all_label=feature.getValue();
				   }
				 }
				 
				 if (mainmenu.isPortfolio()) {
					Vector<String> vMenuSections = StringUtils.StringTokensToVector(Application.getApp().dictionary_menu_section, ",");
					Vector<String> vCommonSections = StringUtils.StringTokensToVector(Application.getApp().dictionary_common_section, ",");
					Vector<String> vAppSections = StringUtils.StringTokensToVector(Application.getApp().dictionary_section, ",");
					Vector<String> vApplications = mainmenu.getOwnSubMenus();
					for (int i=0;i<vApplications.size();i++) {
						String sApplicationName = vApplications.elementAt(i);
						try {
							Feature feature = Feature.open(TAGS.APP_dictionary_menu_section, "Menu",sApplicationName,"","", framework, null);
							if (vMenuSections.indexOf(feature.getValue())<0) {
								vMenuSections.add(feature.getValue());
							}
						} catch (Exception ex) {}
						try {
							Feature feature = Feature.open(TAGS.APP_dictionary_common_section, "Menu",sApplicationName,"","", framework, null);
							if (vCommonSections.indexOf(feature.getValue())<0) {
								vCommonSections.add(feature.getValue());
							}
						} catch (Exception ex) {}
						try {
							Feature feature = Feature.open(TAGS.APP_dictionary_section, "Menu",sApplicationName,"","", framework, null);
							if (vAppSections.indexOf(feature.getValue())<0) {
								vAppSections.add(feature.getValue());
							}
						} catch (Exception ex) {}					
					}			
					Application.getApp().dictionary_menu_section=StringUtils.vectorToString(vMenuSections,",");
					Application.getApp().dictionary_common_section=StringUtils.vectorToString(vCommonSections,",");
					Application.getApp().dictionary_section=StringUtils.vectorToString(vAppSections,",");
					applicationParameters.put(TAGS.APP_dictionary_menu_section,Application.getApp().dictionary_menu_section);
					applicationParameters.put(TAGS.APP_dictionary_common_section,Application.getApp().dictionary_common_section);
					applicationParameters.put(TAGS.APP_dictionary_section,Application.getApp().dictionary_section);
				 }
  			     ServletContext application_context = session.getServletContext();  

				 application_context.setAttribute("applicationParameters",applicationParameters);
	   
				 Hashtable<String,String> langSupportTranslation = new Hashtable<String,String>();
				 String appLanguages = getAppParam("application_Languages");
				 String browserLanguages = getAppParam("browser_Languages");
				 StringTokenizer sTA = new StringTokenizer(appLanguages,",");
				 StringTokenizer sTB = new StringTokenizer(browserLanguages,",");
				 while ( sTA.hasMoreTokens() && sTB.hasMoreTokens() ) {
				  langSupportTranslation.put(sTB.nextToken(),sTA.nextToken());
				 }
				 application_context.setAttribute("langSupportTranslation",langSupportTranslation);

				 Hashtable<String,String> langReverseTranslation = new Hashtable<String,String>();
				 sTA = new StringTokenizer(appLanguages,",");
				 sTB = new StringTokenizer(browserLanguages,",");
				 while ( sTA.hasMoreTokens() && sTB.hasMoreTokens() ) {
				  langReverseTranslation.put(sTA.nextToken(),sTB.nextToken());
				 }	  
				 application_context.setAttribute("langReverseTranslation",langReverseTranslation);
			}
		} catch (Exception ex) { System.out.println("Unable to load application parameters:\n"+ex.getMessage()); }
	  }	 
   }

   // Retrieve application parameter value
   static public String getAppParam(String sParamName) {
      if ( applicationParameters == null || applicationParameters.get(sParamName) == null ) {
	    return "";
	  } else {
		return  applicationParameters.get(sParamName);
	  }
   }

   // Convert the browser language code to the corresponding Oberon dictionary language code
   static public String translateBrowserLanguageToOberonLanguage(String sBrowserLanguage,HttpSession session) {
	  String LANGUAGE = sBrowserLanguage;  
	  Hashtable<String,String> langSupportTranslation = (Hashtable<String,String>)session.getServletContext().getAttribute("langSupportTranslation");
	  if (langSupportTranslation!=null) {
		  String Lang = langSupportTranslation.get(sBrowserLanguage);
		  if (Lang !=null ) { 
			LANGUAGE = Lang; 
		  } else if (getAppParam(TAGS.APP_dictionary_default_language).length()>0) {
			LANGUAGE = getAppParam(TAGS.APP_dictionary_default_language); 
		  } 
	  }
 	  return LANGUAGE;
   }
   
   // Convert the Oberon dictionary language code to the corresponding ISO-639 language code
   static public String translateOberonLanguageToISO639Language(String sOberonLanguage,HttpSession session) {
	  String LANGUAGE = sOberonLanguage;
	  Hashtable<String,String> langReverseTranslation = (Hashtable<String,String>)session.getServletContext().getAttribute("langReverseTranslation");
 	  if (langReverseTranslation != null ) {
		  String Lang = langReverseTranslation.get(sOberonLanguage);
		  if (Lang !=null ) { LANGUAGE = Lang; }
	  }
	  return LANGUAGE;
   }   
   
   static public String getBrowserLanguage(HttpServletRequest request) {
		String sBrowserLang = "en";
	 	String languageStr  = request.getHeader("Accept-Language");
	 	try {
	 	    if ((languageStr != null) && (languageStr.length() > 0)) {
	 	      StringTokenizer LangTokens = new StringTokenizer(languageStr,",");
	 	      if (LangTokens.countTokens() > 0)
	 	    	 sBrowserLang = LangTokens.nextToken();
	 	      else 
	 	    	 sBrowserLang = languageStr;
	 	    }
	 	} catch(Exception e) { }
		return sBrowserLang;
   }
   
   static public String getInputParameter(String sParameterName,HttpServletRequest request) {
	   String sValue = request.getParameter(sParameterName);
	   if ( sValue!=null ) { return sValue.trim(); } else { return ""; }
   }
    
   static public String getDictCommon(HttpSession session) {
	   String sSection = (String)session.getAttribute("CommonSection");
	   if (sSection==null) { sSection="*"; }
	   return sSection;
   }
   
   static public String getRootPath(HttpSession session) {
	   return session.getAttribute("RootPath")+"/";
   }
   
   static public String getIcon(int sId,HttpSession session) {	  
	  return session.getAttribute("RootPath")+"/servlet/JRImageServlet?"+TAGS.id+"="+sId;
   }
   
   static public String getClassIcon(String sClassName,HttpSession session) {
      return session.getAttribute("RootPath")+"/servlet/JRImageServlet?"+TAGS.type+"=Class%2B&"+TAGS.name+"="+sClassName;
   }
   
   static public String drawClassIcon(String sClassName,HttpSession session) {
      return "<img src=\""+getClassIcon(sClassName,session)+"\" style=\"vertical-align:middle;\">";
   }
   
   static public String getHTMLIcon(String iconName){
      return  "<img src=\"./images/"+iconName+"\" border=0 style=\"vertical-align:middle;\">";
   }
   
   static public String switchRowclass(String row) {
	   if (row.equals("dark")) return("light");
	   else return("dark");
   }
   
   static public String encodeURL(String text) {
      try {
		return java.net.URLEncoder.encode(text,StringUtils.UTF8);
	  } catch (UnsupportedEncodingException ex) {
		return text;
	  }
   }
   
   static public String encodeHRef(String text) {
      try {
	    if (text.indexOf('?')>0) {
			StringTokenizer sT = new StringTokenizer(text,"?");
			StringBuffer sBReturn = new StringBuffer(sT.nextToken()).append('?');
			sT = new StringTokenizer(sT.nextToken(),"&");
			while (sT.hasMoreTokens()) {
				String sParameter = sT.nextToken();
				int iPos = sParameter.indexOf('=');
				sBReturn.append(sParameter.substring(0,iPos+1));
				sParameter=sParameter.substring(iPos+1);
				iPos = sParameter.indexOf('\'');  // URL inside javascript
				if (iPos<0) iPos = sParameter.indexOf('\"'); 
				if (iPos>0) {		
				   sBReturn.append(java.net.URLEncoder.encode(sParameter.substring(0,iPos),StringUtils.UTF8)).append(sParameter.substring(iPos)).append('&');
				} else {
				   sBReturn.append(java.net.URLEncoder.encode(sParameter,StringUtils.UTF8)).append('&');
				}
			}	
			String sReturn = sBReturn.toString();
			return sReturn.substring(0, sReturn.length() - 1);		
		} else return text;
	  } catch (UnsupportedEncodingException ex) {
		return text;
	  }
   }

   static public String getClassNameRevision(ObjectObj object,HttpSession session) throws Exception{
	  String sCNR = Dictionary.getKey(dictSection+"*",object.getClassName(),Application.getFramework(session));
      return sCNR+" <b>"+getNameRevision(object.getName(),object.getRevision())+"</b>";
   }
   
   static public String getNameRevision(String sName,String sRevision) {
       sRevision=sRevision.trim();   
	   if (sRevision.length()>0 && !sRevision.equals("-")) {
		   return sName+name_revision_separator+sRevision;
	   } else {
		   return sName;
	   }
   }
   
   static public String getLinkData(Link link,HttpSession session) throws Exception{
  	  Framework framework = Application.getFramework(session);
	  String sCNRF = Dictionary.getKey(dictSection+"*",link.getFromClassName(),framework);
	  if (link.getFromRevision().length()>0 && !link.getFromRevision().equals("-")) {
		  sCNRF+=" <b>"+link.getFromName()+name_revision_separator+link.getFromRevision()+"</b>";
	  } else {
		  sCNRF+=" <b>"+link.getFromName()+"</b>";
	  }
	  String sCNRT = Dictionary.getKey(dictSection+"*",link.getToClassName(),framework);
	  if (link.getToRevision().length()>0 && !link.getToRevision().equals("-")) {
		  sCNRT+=" <b>"+link.getToName()+name_revision_separator+link.getToRevision()+"</b>";
	  } else {
		  sCNRT+=" <b>"+link.getToName()+"</b>";
	  }
	  String sType = Dictionary.getKey(dictSection+"*",link.getLinkType(),framework);
      return sType+" "+sCNRF+" -&gt; "+sCNRT;
   }
  
 	public static void createMenu(String menuName, HttpSession session) {
		session.removeAttribute("Menu");
		Framework framework = Application.getFramework(session);
		try {
			Hashtable<String,Integer> counters = framework.getAdminCounters();
			Menu menu = Menu.open(menuName,framework,counters);
			String sRootPath=(String)session.getAttribute("RootPath");
			if (sRootPath==null) { sRootPath=""; }
			String sDictSection=(String)session.getAttribute("MenuSection");
			if (sDictSection==null) { sDictSection="Menu"; }
			String sMenu = createMenu( menu, framework,sRootPath,sDictSection,counters,0);
			session.setAttribute("Menu",sMenu);
		} catch (Exception ex) {
			 setErrorMessage(session,"Create menu FAILED: <br>"+StringUtils.replaceString(ex.getMessage(),"\n","<br>") );
		}
	}

	// recurse the createMenu for sub-Menus
	private static String createMenu(Menu menu, Framework framework,String sRootPath, String sDictSection ,Hashtable<String,Integer> counters, int level) throws Exception {
		StringBuffer sResult= new StringBuffer();
		String sTab = "";
		for (int i=0;i<=level;i++) {   sTab+="\t";  }
		Vector<String> vElements = menu.getOwnChilds();
		int iSize = vElements.size();
		Vector<Object> vArgs = new Vector<Object>(0);
		for (int i=0;i<iSize;i++) {
			String sCommand =  vElements.elementAt(i);	   
			if (!sCommand.startsWith("+")) {	// Is a command	  
				Command command = Command.open(sCommand,framework,counters);
				if (command.hasAccess(vArgs, framework)) {
					String sLabel = command.getLabel().trim();
					if (sLabel.length()>0) {
						sResult.append(sTab).append("<li");					
						if (level==0) { sResult.append(" class='topl'"); }					
						sResult.append("><a href='").append(sRootPath).append('/').append(encodeHRef(command.getHRef())).append('\'');
						if (level==0) { sResult.append(" class='topl_link'"); }
						sResult.append("><span>");
						if (command.hasImage()) {
							sResult.append("<img src=\"").append(sRootPath);
							sResult.append("/servlet/JRImageServlet?"+TAGS.type+"=Command&").append(TAGS.name).append("=").append(command.getName()).append("\">");
						}   
						sResult.append(Dictionary.getKey(sDictSection,sLabel,framework)).append("</span></a></li>\n");
					} else {
						sResult.append(sTab).append("<li");					
						if (level==0) { sResult.append(" class='spc'"); } else { sResult.append(" class='spc_sub'");  }					
						sResult.append("><span></span></li>\n");
					}
				}
			} else {
				Menu submenu = Menu.open(sCommand.substring(1),framework,counters);
				String sMenuResult=createMenu(submenu,framework,sRootPath,sDictSection,counters,level+1);
				if (sMenuResult.length()>0) {
					sResult.append(sTab).append("<li");
					if (level==0) { sResult.append(" class='topl'"); }
					sResult.append("><a href='#nogo' ");
					if (level==0) { sResult.append(" id='").append(submenu.getName()).append("' class='topl_link'><span class='down'>"); }
					else { sResult.append(" class='fly'><span>"); }
					if (submenu.hasImage()) {
						sResult.append("<img src=\"").append(sRootPath);
						sResult.append("/servlet/JRImageServlet?").append(TAGS.type).append("=Menu&").append(TAGS.name).append("=").append(submenu.getName()).append("\">");
					} 
					sResult.append(Dictionary.getKey(sDictSection,submenu.getLabel().trim(),framework)).append("</span></a>\n");
					if (level==0) { sResult.append(sTab).append(" <ul class='subl'>"); 
					} else { sResult.append(" <ul>"); }
					sResult.append('\n').append(sMenuResult).append('\n').append(sTab).append("</ul>\n").append(sTab).append("</li>\n");
				}
			}	
		}
		return sResult.toString();
	}
   
   static public String createObjectMenu(HttpSession session) {
	   String sResult="";
	   ObjectObj object = (ObjectObj) session.getAttribute(TAGS.Object);
       if ( object != null ) {
 			try {
		    	String sRootPath=getRootPath(session);
				Framework framework = Application.getFramework(session);
		      	sResult="\t<li class='line lrt'><a href='#nogo' ><b class='arrow'><img src=\""+
		      	             sRootPath+menu_files_path+"/object.gif\" style=\"vertical-align:middle;\" border=0> "+
		      	             Dictionary.getKey("Object Options",framework)+"</b></a>\n";
		      	sResult+="\t <ul class='sub rt'>\n";
				Vector<MenuItem> vActions = object.getActions( null,framework);
				if (vActions.size() > 0) {
					for (int i = 0; i < vActions.size(); i++) {
						MenuItem action =  vActions.elementAt(i);
						String sHref=action.getHRef();
		  			    if ( sHref.startsWith("#") ) {
		  				  StringTokenizer sT=new StringTokenizer(sHref.substring(1),";");
						  String sURL = encodeHRef(sT.nextToken());
						  String sWindowName = "PopUp";
						  if (sT.hasMoreTokens()) sWindowName= sT.nextToken();
						  String sParameters = "location=no,menubar=no,titlebar=no,status=yes,width=900,height=500,resizable=yes,scrollbars=yes";
						  if (sT.hasMoreTokens()) sParameters= sT.nextToken();
		  				  sResult+="\t  <li><a href='#nogo' onClick=\"openLink('"+sRootPath+sURL+"&"+TAGS.popup+"=true','"+sWindowName+"','"+sParameters+"')\""; 
		  		  	    } else {
		  				  sResult+="\t  <li><a href='"+sRootPath+encodeHRef(sHref)+"'";
		  		 	    }
		  			    sResult+=">"+action.getTranslatedLabel()+"</a></li>\n";
		  			}
		  	      	sResult+="\t </ul>\n\t</li>\n";
				}
    	 } catch (Exception e) {
    		 setErrorMessage(session,"Create object menu FAILED: <br>"+
    	    		 StringUtils.replaceString(e.getMessage(),"\n","<br>") );
    	 }
      }
      return sResult;
   }
   
   static public void setErrorMessage(HttpSession session,String sMessage) {
		session.setAttribute(TAGS.errormessage,sMessage);
   }
   
   static public String getErrorMessage(HttpSession session) {
       String sMessage = (String)session.getAttribute(TAGS.errormessage);
	   if (sMessage!=null) {
	 	 int iline=sMessage.indexOf(", on line");
		 if (iline>0) sMessage=sMessage.substring(0,iline);
		 session.removeAttribute(TAGS.errormessage);
	   } else {
		 sMessage="";
	   }
	   return sMessage;
   }
%><%  
   ServletContext application_context = session.getServletContext();   
   applicationParameters  = (Hashtable<String,String>)application_context.getAttribute("applicationParameters");   
   name_revision_separator = getAppParam(TAGS.APP_name_revision_separator);
					
   application_main_menu=application_context.getInitParameter("application_main_menu");
   anonymous_user_name=application_context.getInitParameter("anonymous_user_name");
   anonymous_user_password=application_context.getInitParameter("anonymous_user_password");
   use_browser_language=application_context.getInitParameter("use_browser_language").equalsIgnoreCase("true");   
%>