<%@page import="sun.reflect.ReflectionFactory.GetReflectionFactoryAction"%>
<SCRIPT src="<%= getRootPath(session) %>common/scripts/forms.js" type=text/javascript></SCRIPT>
 <SCRIPT src="<%= getRootPath(session) %>common/scripts/calendar.js" type=text/javascript></SCRIPT>
 <SCRIPT src="<%= getRootPath(session) %>common/scripts/popup.js" type=text/javascript></SCRIPT> 
 <SCRIPT src="<%= getRootPath(session) %>common/scripts/lifecycle.js" type=text/javascript></SCRIPT>
 <STYLE type=text/css media=all>@import url(<%= getRootPath(session) %>common/css/forms.css);</STYLE>
 <STYLE type=text/css media=all>@import url(<%= getRootPath(session) %>common/css/calendar.css);</STYLE>

<%@ page import = "com.oberon.ooql.sdk.*,
				   com.oberon.ooql.sdk.Dictionary,
                   com.oberon.util.*,
                   com.oberon.client.*,
				   org.jdom.Element,
                   java.text.*,
                     java.util.*"
%><%!   
	static private String  number_separator_symbols ;
	static private boolean use_search_patterns ;
	static private String ELEMENT_FORM = "<EL-form>";

	private static String addSearchCheck(FormUserItem fuitem, String sForm, String section, Locale locale, Framework framework) throws Exception {
		String sReturn = "";
		String sFormat = fuitem.getFormat();
		String sLabel = StringUtils.getTagValue(sFormat, TAGS.FORM_Label);
		if (sLabel.trim().length() == 0) {
			sLabel = StringUtils.getTagValue(fuitem.getFormat(), TAGS.FORM_LabelCell);
		}
		if (fuitem.isEditable() && fuitem.isRequired()) {
			sReturn+=" && isNotIgnored('"+sForm+"','"+ fuitem.getItemFormName() + "','"+ fuitem.getLabel() + "')";
		}

		String format;
		if ((format = StringUtils.getTagValue(sFormat, TAGS.FORM_TypeInteger)).length() > 0) {
			sReturn+=" && isFieldInteger('"+sForm+"','"+ fuitem.getItemFormName() + "','?"+format+"','"+ fuitem.getLabel() + "')";		 
		} else if ((format = StringUtils.getTagValue(sFormat, TAGS.FORM_TypeReal)).length() > 0) {
			if (number_separator_symbols != null && number_separator_symbols.length() == 2) {
				format = format.replace('.', number_separator_symbols.charAt(1));
			} else {
				DecimalFormatSymbols newSymbols = new DecimalFormatSymbols(locale);
				format = format.replace('.', newSymbols.getDecimalSeparator());
			}
			sReturn+=" && isFieldFloat('"+sForm+"','"+ fuitem.getItemFormName() + "','?"+format+"','"+ fuitem.getLabel() + "')";
		}
		return sReturn;
	}

	private static String addCheck(FormUserItem fuitem, String sForm, String section, Locale locale, Framework framework) throws Exception {
		String sReturn = "";
		String sFormat = fuitem.getFormat();
		String sLabel = StringUtils.getTagValue(sFormat, TAGS.FORM_Label);
		if (sLabel.trim().length() == 0) {
			sLabel = StringUtils.getTagValue(fuitem.getFormat(), TAGS.FORM_LabelCell);
		}
		if (fuitem.isEditable() && fuitem.isRequired()) {
			sReturn+=" && isNotEmpty('"+sForm+"','"+ fuitem.getItemFormName() + "','"+ fuitem.getLabel() + "')";
		}
		String format;
		if ((format = StringUtils.getTagValue(sFormat, TAGS.FORM_TypeInteger)).length() > 0) {
			sReturn+=" && isFieldInteger('"+sForm+"','"+ fuitem.getItemFormName() +"','"+format+"','"+ fuitem.getLabel() + "')";
		} else if ((format = StringUtils.getTagValue(sFormat, TAGS.FORM_TypeReal)).length() > 0) {
			if (number_separator_symbols != null && number_separator_symbols.length() == 2) {
				format = format.replace('.', number_separator_symbols.charAt(1));
			} else {
				DecimalFormatSymbols newSymbols = new DecimalFormatSymbols(locale);
				format = format.replace('.', newSymbols.getDecimalSeparator());
			}
			sReturn+=" && isFieldFloat('"+sForm+"','"+ fuitem.getItemFormName() +"','"+format+"','"+ fuitem.getLabel() + "')";	 
		} else if ((format = StringUtils.getTagValue(sFormat, TAGS.FORM_TypeDate)).length() > 0) {
			sReturn+=" && isFieldDate('"+sForm+"','"+ fuitem.getItemFormName() +"','"+format+"','"+ fuitem.getLabel() + "')";
		} else if ((format = StringUtils.getTagValue(sFormat, TAGS.FORM_TypeString)).length() > 0) {
			sReturn+=" && isFieldString('"+sForm+"','"+ fuitem.getItemFormName() +"','"+format+"','"+ fuitem.getLabel() + "')";
		} else if ((format = StringUtils.getTagValue(sFormat, TAGS.FORM_TypeRegExpr)).length() > 0) {
			sReturn+=" && checkRegExpr('"+sForm+"','"+ fuitem.getItemFormName() +"','"+format+"','"+ fuitem.getLabel() + "')";
		}
		return sReturn;
	}

	private static String getLabel(FormUserItem fuitem, String section, Framework framework) throws Exception {
		String sReturn="";
		String sLabel = StringUtils.getTagValue(fuitem.getFormat(), TAGS.FORM_Label);
		if (sLabel.length() > 0) {
			sReturn+="<div class=label >"+fuitem.getLabel();	      
			if (fuitem.isEditable() && fuitem.isRequired()) {
				sReturn+="<font color=red>*</font>"; 
			}
			sReturn+="</div>&nbsp;";		 
		}
		return sReturn;
	}

	private static String getTDLabel(FormUserItem fuitem, String section, Framework framework) throws Exception {
		String sReturn="";
		String sLabel = StringUtils.getTagValue(fuitem.getFormat(), TAGS.FORM_LabelCell);
		if (sLabel.length() > 0) {
			sReturn+="\t\t  <td class=tdlabel valign=top >"+fuitem.getLabel();
			if (fuitem.isEditable() && fuitem.isRequired()) {
				sReturn+="<font color=red>*</font>"; 
			}
			sReturn+="</td>\n";		 
		}
		return sReturn;
	}

	private static String getHrefLabel(String sHref) {
		String sLabel;
		int iPos = sHref.indexOf('?');
		if (iPos > 0) {
			sLabel = sHref.substring(0, iPos);
		} else {
			sLabel = sHref;
		}
		sLabel = StringUtils.replaceString(sLabel, "%40", "@");
		if (sLabel.startsWith(TAGS.PAGE_Url_http)) {
			sLabel = sLabel.substring(7);
		} else if (sLabel.startsWith(TAGS.PAGE_Url_https)) {
			sLabel = sLabel.substring(8);
		} else if (sLabel.startsWith(TAGS.PAGE_Url_mailto)) {
			sLabel = sLabel.substring(7);
		} else if (sLabel.startsWith(TAGS.PAGE_Mail)) {
			sLabel = StringUtils.getStringPart(sHref,TAGS.email+"=","&");
		}
		return sLabel;
	}

	private static Vector<String> getActionButtons(FormUserItem fuitem) throws Exception {
		String sFormat = fuitem.getFormat();
		String sButtons = StringUtils.getTagValue(sFormat, TAGS.FORM_ActionButtons);
		if (sButtons.length() > 0) {
			return StringUtils.StringTokensToVector(sButtons, "|");
		}
		return new Vector<String>(0);
	}

	private static String getTD(FormUserItem fuitem, String section, Framework framework) throws Exception {
		String sReturn=getTDLabel(fuitem,section,framework); 
		String sTD = StringUtils.getTagValue(fuitem.getFormat(), TAGS.FORM_GridCell);
		boolean bTD = false;
		if (sTD.length() > 0) {
			StringTokenizer sT = new StringTokenizer(sTD, ",");
			sReturn+="\t\t  <td valign=top colspan=\""+sT.nextToken()+"\" ";

			if (sT.hasMoreTokens()) {
				sReturn+="rowspan=\""+sT.nextToken()+"\" ";
			}
			if (sT.hasMoreTokens()) {
				sReturn+="class=\""+sT.nextToken()+"\" ";
			} else if ( fuitem.getType()==Item.ITEMTYPE_SECTION ) { sReturn+=" class=section"; }
			bTD = true;
		} else if (fuitem.getFormat().indexOf(TAGS.FORM_GridCellStart) >= 0) {
			sReturn+="\t\t  <td valign=top";
			if ( fuitem.getType()==Item.ITEMTYPE_SECTION ) { sReturn+=" class=section"; }
			bTD = true;
		}
		if (bTD) {

			// Set width/height
			if (fuitem.getType() == Item.ITEMTYPE_SECTION) {
				if (fuitem.getWidth() > 0) {
					sReturn+=" width=\""+Math.round(fuitem.getWidth())+"px\"";
				}
				if (fuitem.getHeight() > 0) {
					sReturn+=" height=\""+Math.round(fuitem.getHeight())+"px\"";
				}
			}
			sReturn+=">\n";
		}
		return sReturn;
	}

	private static String getEndTD(FormUserItem fuitem) throws Exception {
		String sReturn = "";
		if (fuitem.getFormat().indexOf(TAGS.FORM_GridCellEnd) >= 0) {
			sReturn+="\t\t  </td>\n";
		}    
		if (fuitem.getFormat().indexOf(TAGS.FORM_GridRowEnd) >= 0) {
			sReturn+=("\t\t </tr>\n\t\t <tr>\n"); 
		}
		return sReturn;
	}

	private static String getDateFormat(String sFormat) {
		String sDateFormat = StringUtils.getTagValue(sFormat, TAGS.FORM_TypeDate);
		if (sDateFormat.length() > 0) {
			return sDateFormat;
		} else {
			return "yyyy-MM-dd";
		}
	}

	private static String setNumberFormat(String sFormat,Locale locale) {
		String sNumFormat = StringUtils.getTagValue(sFormat, TAGS.FORM_TypeReal);
		if (sNumFormat.length() > 0) {
			if (number_separator_symbols.length() == 2) {
				sNumFormat = sNumFormat.replace('.', number_separator_symbols.charAt(1));
			} else {
				DecimalFormatSymbols newSymbols = new DecimalFormatSymbols(locale);
				sNumFormat = sNumFormat.replace('.', newSymbols.getDecimalSeparator());
			}
			return " numformat=\""+sNumFormat+"\""; 
		} else {
			return ""; 
		}
	}

	private static String getPopUpParameters(String sFormat) {
		return StringUtils.getTagValue(sFormat, TAGS.FORM_PopWinParameters);
	}

	private static String getPopUpURL(String sFormat) {
		return encodeHRef(StringUtils.getTagValue(sFormat, TAGS.FORM_PopWinURL));
	}

	public static java.util.Comparator<?> displayTagComparator(String formatTags, Locale locale) {
		String format;
		if ((format = StringUtils.getTagValue(formatTags, TAGS.FORM_TypeDate)).length() > 0) {
			return new com.oberon.util.DateStringComparator(format, locale);
		} else if ((format = StringUtils.getTagValue(formatTags, TAGS.FORM_TypeReal)).length() > 0) {
			return new com.oberon.util.NumberComparator();
		} 
//		return new org.displaytag.model.DefaultComparator() ;		 
		return new com.oberon.util.CaseInsensitiveComparator();
	}

	private static String getDummyValue(FormUserItem fuitem) {
		String value ;
		String formatTags = fuitem.getFormat();
		if (( StringUtils.getTagValue(formatTags, TAGS.FORM_TypeDate)).length() > 0) {
			try {
				value = JLClient.dateFormat.format(new Date());
			} catch (Exception e) {
				value = "";
			}
		} else if (( StringUtils.getTagValue(formatTags, TAGS.FORM_TypeReal)).length() > 0) {
			value = "12.34567890";
		} else if (( StringUtils.getTagValue(formatTags, TAGS.FORM_TypeInteger)).length() > 0) {
			value = "1234567890";
		} else {
			value = "< "+fuitem.getName()+" - value >"; 
		}
		return value;
	}

	public static String getColumnText(Element eText) {
		return getColumnText(eText,0);
	}

	private static String getColumnText(Element eText,int ilevel) {	   

		if (eText.getChildren().size()==0) {
			return eText.getText();
		} else {
			Iterator<?> itr = eText.getChildren().iterator();
			String sReturn="";
			while (itr.hasNext()) {
				Element eSubText = (Element) itr.next();
				for (int j=0;j<ilevel;j++) { sReturn+="&nbsp;"; }
				sReturn+=getColumnText(eSubText,ilevel+1)+"<br>";
			}
			return sReturn;
		}

	}

	public static String formatForCompare(String sValue) {
		int iPos = sValue.indexOf('.');
		if ( iPos>=0 ) {
			iPos=15-iPos;
		} else {
			iPos=15-sValue.length();
			sValue+=".000000000";
		}
		for (int i=0;i<iPos;i++) { sValue="0"+sValue; }
		return sValue;
	}

	private static boolean selected(String sKeyValue, String sDataValue) {
		return (Field.ATTRSEP + sDataValue + Field.ATTRSEP).indexOf(Field.ATTRSEP + sKeyValue + Field.ATTRSEP) >= 0;
	}

	private static String addFormText(FormUserItem fuitem, String sValue,Locale locale,int iWidth,String sPrefix) {
		StringBuffer sReturn=new StringBuffer("\t\t   <input ");
		String sItemFormat = fuitem.getFormat();
		if (sItemFormat.indexOf("<"+TAGS.FORM_TypeRegExpr+"["+TAGS.FORM_Input_PASSWORD+"]>") >= 0) {
			sReturn.append("type=").append(TAGS.FORM_ControlPassword);
		} else {
			sReturn.append("type=").append(TAGS.FORM_ControlText);
		}
		sReturn.append(" id=\"").append(TAGS.ELEMENT_ID).append("\"");
		sReturn.append(" name=\"").append(TAGS.ELEMENT_NAME).append("\"");
		sReturn.append(" style=\"width:").append(iWidth>0?iWidth:Math.round(fuitem.getWidth())).append("px\"");
		sReturn.append(setNumberFormat( fuitem.getFormat() ,locale ));
		sReturn.append(" value=\"").append(sValue).append("\"");
		if (!fuitem.isEditable() || fuitem.isDisabled()) {
			sReturn.append(" disabled ");
		}
		if (sItemFormat.indexOf(TAGS.FORM_Reload_Items) >= 0) {
			sReturn.append(" onchange=\"refresh").append(sPrefix).append("Fields(this.name)\" "); 
		} else if (sItemFormat.indexOf(TAGS.FORM_Reload_Page) >= 0) {
			sReturn.append(" onchange=\"refresh").append(sPrefix).append("Page(this.name)\" "); 
		}
		sReturn.append(">\n");	
		return sReturn.toString();	   
	}

	private static String addFormTextArea(FormUserItem fuitem, String sValue,int iWidth,String sPrefix) {
		String sItemFormat = fuitem.getFormat();
		StringBuffer sReturn=new StringBuffer("\t\t   <textarea");
		sReturn.append(" id=\"").append(TAGS.ELEMENT_ID).append("\"");
		sReturn.append(" name=\"").append(TAGS.ELEMENT_NAME).append("\"");
		sReturn.append(" style=\"width:").append(iWidth>0?iWidth:Math.round(fuitem.getWidth())).append("px\"");
		sReturn.append(" rows=\"").append(Math.round(fuitem.getHeight()+1)).append("\" wrap");
		if (!fuitem.isEditable() || fuitem.isDisabled()) {
			sReturn.append(" disabled ");
		}
		if (sItemFormat.indexOf(TAGS.FORM_Reload_Items) >= 0) {
			sReturn.append(" onchange=\"refresh").append(sPrefix).append("Fields(this.name)\" "); 
		} else if (sItemFormat.indexOf(TAGS.FORM_Reload_Page) >= 0) {
			sReturn.append(" onchange=\"refresh").append(sPrefix).append("Page(this.name)\" "); 
		}
		sReturn.append("\n\t\t   >").append(sValue).append("</textarea>\n");
		return sReturn.toString();	  
	}

	private static String addFormSelect(FormUserItem fuitem, String sSelectedValue, Vector<?> vValues, int iWidth,String sPrefix) {
		String sItemFormat = fuitem.getFormat();
		StringBuffer sReturn=new StringBuffer("\t\t   <select");
		sReturn.append(" id=\"").append(TAGS.ELEMENT_ID).append("\"");
		sReturn.append(" name=\"").append(TAGS.ELEMENT_NAME).append("\"");
		int iRows = (int)fuitem.getHeight();
		if (iWidth>=0) {
		  sReturn.append(" style=\"width:").append(iWidth>0?iWidth:Math.round(fuitem.getWidth())).append("px\"");
		}
		if (fuitem.isFieldMultipleSelection()) { 
			sReturn.append(" multiple=\"multiple\" "); 
			iRows = (int)Math.max(3,fuitem.getHeight())+1;
		} 
		sReturn.append(" size=\"").append(iRows).append("\"");
		if (!fuitem.isEditable() || fuitem.isDisabled()) {
			sReturn.append(" disabled ");
		}
		if (sItemFormat.indexOf(TAGS.FORM_Reload_Items) >= 0) {
			sReturn.append(" onchange=\"refresh").append(sPrefix).append("Fields(this.name)\" "); 
		} else if (sItemFormat.indexOf(TAGS.FORM_Reload_Page) >= 0) {
			sReturn.append(" onchange=\"refresh").append(sPrefix).append("Page(this.name)\" "); 
		} 
		sReturn.append("></select>");

		sReturn.append("\n\t\t<script>").append("\n\t\t var values=[");
		int iSize = vValues.size();
		for (int j = 0; j < iSize; j++) {
			try {
				Object value = vValues.elementAt(j);
				if (j>0) sReturn.append(",");
				if ( value instanceof FormUserItem.Value ) {
					sReturn.append("\"").append(((FormUserItem.Value)value).getDisplayValue()).append("|").append(((FormUserItem.Value)value).getDataValue()).append("\"");
				} else {
					sReturn.append("\"").append(value.toString()).append("\"");
				}				
			} catch (Exception exp) {}
		}
		sReturn.append("];");
		if (fuitem.isFieldMultipleSelection()) { 
			sReturn.append("\n\t\t setListValues(").append(ELEMENT_FORM).append(".elements[\"").append(TAGS.ELEMENT_ID).append("\"],'").append(sSelectedValue).append("',values);\n\t\t</script>\n");
		} else {
			sReturn.append("\n\t\t setSelectValues(").append(ELEMENT_FORM).append(".elements[\"").append(TAGS.ELEMENT_ID).append("\"],'").append(sSelectedValue).append("',values);\n\t\t</script>\n");
		}
		return sReturn.toString();
	}

	private static String addFormListBox(FormUserItem fuitem, String sSelectedValue, Vector<Object> vValues, int iWidth,String sPrefix) {
		String sItemFormat = fuitem.getFormat();
		StringBuffer sReturn=new StringBuffer("\t\t   <table><tr><td rowspan=2>");
		sReturn.append("\t\t\t   <select");
		sReturn.append(" id=\"").append(TAGS.ELEMENT_ID).append("_list\"");
		sReturn.append(" name=\"").append(TAGS.ELEMENT_NAME).append("_list\"");
		int iRows = (int)fuitem.getHeight();
		if (iWidth>=0) {
		  sReturn.append(" style=\"width:").append(iWidth>0?iWidth:Math.round(fuitem.getWidth()/2-40)).append("px\"");
		}
		sReturn.append(" multiple=\"multiple\" "); 
		iRows = (int)Math.max(3,fuitem.getHeight())+1;
		sReturn.append(" size=\"").append(iRows).append("\"");
		if (!fuitem.isEditable() || fuitem.isDisabled()) {
			sReturn.append(" disabled ");
		}
		sReturn.append("></select>");
		sReturn.append("\t\t   </td><td rowspan=2 >");
		if (fuitem.isEditable() && !fuitem.isDisabled()) {
			sReturn.append("<input type=button value=\"&#9658;\" onClick=\"listbox_moveacross('").append(TAGS.ELEMENT_ID).append("_list', '").append(TAGS.ELEMENT_ID).append("')\"><br/>");
			sReturn.append("<input type=button value=\"&#9668;\" onclick=\"listbox_moveacross('").append(TAGS.ELEMENT_ID).append("', '").append(TAGS.ELEMENT_ID).append("_list')\"><br/><br/>");
		}
		sReturn.append("\t\t   </td><td rowspan=2>");
		sReturn.append("\t\t\t   <select");
		sReturn.append(" id=\"").append(TAGS.ELEMENT_ID).append("\"");
		sReturn.append(" name=\"").append(TAGS.ELEMENT_NAME).append("\"");
		if (iWidth>=0) {
		  sReturn.append(" style=\"width:").append(iWidth>0?iWidth:Math.round(fuitem.getWidth()/2-40)).append("px\"");
		}
		sReturn.append(" multiple=\"multiple\" "); 
		sReturn.append(" size=\"").append(iRows).append("\"");
		if (!fuitem.isEditable() || fuitem.isDisabled()) {
			sReturn.append(" disabled ");
		}
		sReturn.append("></select>");
		sReturn.append("\t\t   </td><td valign=top>");
		if (fuitem.isEditable() && !fuitem.isDisabled()) {
			sReturn.append("<input type=button value=\"&#9650;\" onClick=\"listbox_move('").append(TAGS.ELEMENT_ID).append("', 'up')\"><br/>");
			sReturn.append("\t\t   </td></tr><td valign=bottom>");
			sReturn.append("<input type=button value=\"&#9660;\" onclick=\"listbox_move('").append(TAGS.ELEMENT_ID).append("', 'down')\">");
		}
		sReturn.append("\t\t   </td></tr></table>");
		
		/*if (sItemFormat.indexOf(TAGS.FORM_Reload_Items) >= 0) {
			sReturn.append(" onchange=\"refresh").append(sPrefix).append("Fields(this.name)\" "); 
		} else if (sItemFormat.indexOf(TAGS.FORM_Reload_Page) >= 0) {
			sReturn.append(" onchange=\"refresh").append(sPrefix).append("Page(this.name)\" "); 
		} */
		
		sReturn.append("\n\t\t<script>").append("\n\t\t var values=[");
		int iSize = vValues.size();
		for (int j = 0; j < iSize; j++) {
			try {
				Object value = vValues.elementAt(j);
				if (j>0) sReturn.append(",");
				if ( value instanceof FormUserItem.Value ) {
					sReturn.append("\"").append(((FormUserItem.Value)value).getDisplayValue()).append("|").append(((FormUserItem.Value)value).getDataValue()).append("\"");
				} else {
					sReturn.append("\"").append(value.toString()).append("\"");
				}				
			} catch (Exception exp) {}
		}
		sReturn.append("];");
		sReturn.append("\n\t\t setListBoxValues(").append(ELEMENT_FORM).append(".elements[\"").append(TAGS.ELEMENT_ID).append("_list\"],")
		                                          .append(ELEMENT_FORM).append(".elements[\"").append(TAGS.ELEMENT_ID).append("\"],'")
												  .append(sSelectedValue).append("',values);\n\t\t</script>\n");		
		return sReturn.toString();
	}

	
	private static String addFormCheck(FormUserItem fuitem, String sValue, FormUserItem.Value sRangeValue, boolean bMulti, String sPrefix) {
		String sItemFormat = fuitem.getFormat();
		String sDataValue =  sRangeValue.getDataValue();		
		String sDisplayValue = sRangeValue.getDisplayValue();
		StringBuffer sReturn=new StringBuffer(" <input ");
		if (bMulti) {
			sReturn.append("type=").append(TAGS.FORM_ControlCheckbox);

		} else {
			sReturn.append("type=").append(TAGS.FORM_ControlRadio);
		}
		sReturn.append(" id=\"").append(TAGS.ELEMENT_ID).append("\"");
		if (bMulti) {
			sReturn.append(" name=\"").append(TAGS.ELEMENT_NAME).append("[]\"");
		} else {
			sReturn.append(" name=\"").append(TAGS.ELEMENT_NAME).append("\"");
		}		
		sReturn.append(" value=\"").append(sDataValue).append("\"");
		if (!fuitem.isEditable() || fuitem.isDisabled()) {
			sReturn.append(" disabled ");
		}
		if (selected(sDataValue, sValue)) {
			sReturn.append(" checked ");
		}
		if (sItemFormat.indexOf(TAGS.FORM_Reload_Items) >= 0) {
			sReturn.append(" onClick=\"refresh").append(sPrefix).append("Fields(this.name)\" "); 
		} else if (sItemFormat.indexOf(TAGS.FORM_Reload_Page) >= 0) {
			sReturn.append(" onchange=\"refresh").append(sPrefix).append("Page(this.name)\" "); 
		} 
		sReturn.append("/>\n");
		sReturn.append("\t\t   <label for=\"").append(TAGS.ELEMENT_ID).append("\" class=opt>");
		sReturn.append(sDisplayValue).append("</label>");
		return sReturn.toString();
	}

	private static String addFormDateText(FormUserItem fuitem, String sValue, String language,int iWidth,String sPrefix,HttpSession session) {	
		String sItemFormat = fuitem.getFormat();
		StringBuffer sReturn= new StringBuffer("\t\t   <input type=").append(TAGS.FORM_ControlText);
		sReturn.append(" id=\"").append(TAGS.ELEMENT_ID).append("\"");
		sReturn.append(" name=\"").append(TAGS.ELEMENT_NAME).append("\"");
		sReturn.append(" style=\"width:").append(iWidth>0?iWidth:Math.round(fuitem.getWidth())).append("px;\"")
		.append(" picker=date datelang=\"").append(language).append("\"")
		.append(" dateformat=\"").append(getDateFormat(sItemFormat)).append("\" ");
		sReturn.append(" value=\"").append(sValue).append("\"");
		if (!fuitem.isEditable() || fuitem.isDisabled()) {
			sReturn.append(" disabled ");
		}
		if (sItemFormat.indexOf(TAGS.FORM_Reload_Items) >= 0) {
			sReturn.append(" onchange=\"refresh").append(sPrefix).append("Fields(this.name)\" "); 
		} else if (sItemFormat.indexOf(TAGS.FORM_Reload_Page) >= 0) {
			sReturn.append(" onchange=\"refresh").append(sPrefix).append("Page(this.name)\" "); 
		}
		sReturn.append(">\n");

		if ( !useNiceForms ) { // when the niceform is disabled 
			sReturn.append("\t\t   <a href=\"javascript: showCalendar('");
			sReturn.append(language).append("','")
			.append(getDateFormat(sItemFormat)).append("','")
			.append(TAGS.ELEMENT_ID).append("')\">");
			sReturn.append("<img style=\"vertical-align:middle;\" border=0 src=\"").append(getRootPath(session)).append("common/images/calendar_icon.png\"></a>\n");
		} 
		return sReturn.toString();
	}

	private static String addFormPopUpText(FormUserItem fuitem, String sValue,int iWidth,String sPrefix,HttpSession session) {
		String sItemFormat = fuitem.getFormat();
		StringBuffer sReturn= new StringBuffer("\t\t   <input type=").append(TAGS.FORM_ControlText);
		sReturn.append(" id=\"").append(TAGS.ELEMENT_ID).append("\"");
		sReturn.append(" name=\"").append(TAGS.ELEMENT_NAME).append("\"");
		sReturn.append(" style=\"width:").append(iWidth>0?iWidth:Math.round(fuitem.getWidth())).append("px;\"")
		.append(" picker=popup popstyle=\"").append(getPopUpParameters(sItemFormat)).append("\"")
		.append(" url=\"").append(getPopUpURL(sItemFormat)).append("\" ");
		sReturn.append(" value=\"").append(sValue).append("\"");
		if (!fuitem.isEditable() || fuitem.isDisabled()) {
			sReturn.append(" disabled ");
		}
		if (sItemFormat.indexOf(TAGS.FORM_Reload_Items) >= 0) {
			sReturn.append(" onchange=\"refresh").append(sPrefix).append("Fields(this.name)\" "); 
		} else if (sItemFormat.indexOf(TAGS.FORM_Reload_Page) >= 0) {
			sReturn.append(" onchange=\"refresh").append(sPrefix).append("Page(this.name)\" "); 
		}
		sReturn.append(">\n");
		if ( !useNiceForms ) { // when the niceform is disabled 
			sReturn.append("\t\t   <a href=\"javascript: showPopUp('");
			sReturn.append(getPopUpURL(sItemFormat)).append("','")
			.append(getPopUpParameters(sItemFormat)).append("','")
			.append(TAGS.ELEMENT_ID).append("')\">");
			sReturn.append("<img style=\"vertical-align:middle;\" border=0 src=\"").append(getRootPath(session)).append("common/images/popup_icon.png\"></a>\n");
		} 
		return sReturn.toString();
	}

	private static String addFormHRef(FormUserItem fuitem) {
		StringBuffer sReturn= new StringBuffer();
		String sHref = encodeHRef( fuitem.getValue().getDataValue() );
		sReturn.append("\t\t   <a href=\"").append(sHref).append("\" ");
		sReturn.append(StringUtils.getTagValue(fuitem.getFormat(),TAGS.FORM_Format)).append(" >")
		.append(HTMLUtil.unescapeHTML(getHrefLabel(fuitem.getValue().getDisplayValue()))).append("</a>\n");
		return sReturn.toString();
	}

	private static String addFormImage(FormUserItem fuitem, String sURL) {
		StringBuffer sReturn= new StringBuffer();
		sReturn.append("\t\t   <img src=\"").append(sURL).append("\" ").append(StringUtils.getTagValue(fuitem.getFormat(),TAGS.FORM_Format));
		sReturn.append(fuitem.getWidth()>0?" width="+Math.round(fuitem.getWidth()):"");
		sReturn.append(fuitem.getHeight()>0?" height="+Math.round(fuitem.getHeight()):"");
		sReturn.append(">\n");
		return sReturn.toString();
	}
	private static String addFormObject(FormUserItem fuitem, String sURL) {
		StringTokenizer sT = new StringTokenizer(sURL, "|");
		sURL = sT.nextToken();
		StringBuffer sReturn= new StringBuffer("\t\t   <iframe type=\"text/html\" ");	
		if (fuitem.getWidth()>0) { sReturn.append(" width=").append(Math.round(fuitem.getWidth())); }
		if (fuitem.getWidth()>0) { sReturn.append(" height=").append(Math.round(fuitem.getHeight())); }
        sReturn.append(" src=\"").append(sURL).append("\" ").append(StringUtils.getTagValue(fuitem.getFormat(),TAGS.FORM_Format));
		sReturn.append("></iframe>\n");	
		return sReturn.toString();
	}

	public static String getFormHTMLName(Form form) {
		return StringUtils.replaceString(StringUtils.replaceString(form.getName(), "-", ""), " ", "");
	}

	public static String createHTMLForm( String actionPage, ObjectBase objlink, Form form, ApplicationRequest request) {
       return createHTMLForm( actionPage , objlink , form , false,"",  request);
	}

	public static String createHTMLSearchForm( String actionPage, Form form, ApplicationRequest request) {
		return createHTMLForm( actionPage,null,form,true,"",request);
	}

	public static String createHTMLForm( String actionPage, ObjectBase objlink, Form form, boolean bSearch, String sPrefix , ApplicationRequest request) {
		
		if (form==null)   { return ""; }
		if (!bSearch && objlink == null) {	return null; }
		StringBuffer sReturn=new StringBuffer();
		String formName = form.getName();	
		String formHTMLName = getFormHTMLName(form);
		try {
			// Parse the input request
			HttpSession session = request.getSession();
			Framework framework = Application.getFramework(session);			
			Locale locale = new Locale(translateOberonLanguageToISO639Language(framework.getLanguage(),session)); 
		
			boolean bCreate   = (request.getParameter(TAGS.create) != null); // Create new object/link
			boolean bUpdate   = (request.getParameter(TAGS.update) != null); // Update the object/link
			boolean bSearched = (request.getParameter(TAGS.search) != null); // Refine the search filters
			boolean bClone    = (request.getParameter(TAGS.clone)  != null); // Clone an object
			boolean bPreview  = (request.getParameter(TAGS.preview)!= null); // Show the form preview with dummy data 			 
			boolean bPrint    = actionPage.equals(TAGS.FORM_ActionPrint);
			
			String sID="";
			boolean bCreateNew = true;
			if (objlink!=null) {
				sID = objlink.getID();
				if (sID.length() > 0 && !bCreate && !bClone) {
					bCreateNew = false;
				}
			} 

			StringTokenizer sTAction = new StringTokenizer(actionPage,"#");
			actionPage=sTAction.nextToken();
			String sActionTarget="";
			if (sTAction.hasMoreTokens()) { sActionTarget=sTAction.nextToken(); }

 	 	  // Prepare the action request
			if (!bPrint) {
				sReturn.append("\t <FORM name=\"").append(formHTMLName).append("\" action=\"").append(actionPage).append("\" target=\"").append(sActionTarget).append("\" method=post ").append((useNiceForms?"class=niceform":"")).append(" onsubmit=\"return check").append(sPrefix).append("Fields('").append(formHTMLName).append("')\">\n");
				if (bSearch) {
					sReturn.append("\t  <input name=").append(TAGS.search).append(" type=").append(TAGS.FORM_ControlHidden).append(" value=true>\n");
				} else {
					sReturn.append("\t  <input name=").append(TAGS.update).append(" type=").append(TAGS.FORM_ControlHidden).append(" value=true>\n");
				}				
				if (bClone) {
					sReturn.append("\t  <input name=").append(TAGS.clone).append(" type=").append(TAGS.FORM_ControlHidden).append(" value=true>\n");
				}
				if (bPreview) {
					sReturn.append("\t  <input name=").append(TAGS.preview).append(" type=").append(TAGS.FORM_ControlHidden).append(" value=true>\n");
				}			 
				if (!bCreateNew && !bSearch) {
					sReturn.append("\t  <input name=").append(TAGS.id).append(" type=").append(TAGS.FORM_ControlHidden).append(" value=\"").append(sID).append("\">\n"); 
				} else {
					if (request.getParameter(TAGS.link) != null) {
						sReturn.append("\t  <input name=").append(TAGS.link).append(" type=").append(TAGS.FORM_ControlHidden).append(" value=\"").append(request.getParameter(TAGS.link)).append("\">\n");
					}
				}
				if (request.getParameter(TAGS.popup) != null) {
					sReturn.append("\t  <input name=").append(TAGS.popup).append(" type=").append(TAGS.FORM_ControlHidden).append(" value=\"").append(request.getParameter(TAGS.popup)).append("\">\n");
				}
				if (request.getParameter(TAGS.inline)!=null) {
					sReturn.append("\t  <input name=").append(TAGS.inline).append(" type=").append(TAGS.FORM_ControlHidden).append(" value=\"").append(request.getParameter(TAGS.inline)).append("\">\n");
				}
				if (request.getParameter(TAGS.dorefresh) != null) {
					sReturn.append("\t  <input name=").append(TAGS.dorefresh).append(" type=").append(TAGS.FORM_ControlHidden).append(" value=\"").append(request.getParameter(TAGS.dorefresh)).append("\">\n");
				}
				sReturn.append("\t  <input name=").append(TAGS.form).append(" type=").append(TAGS.FORM_ControlHidden).append(" value=\"").append(formName).append("\">\n"); 
			}

			String sActionField = request.getParameter(TAGS.activefield);
			if (sActionField == null) {	sActionField = ""; }
			sReturn.append("\t  <input name=").append(TAGS.activefield).append(" type=").append(TAGS.FORM_ControlHidden).append(" value=\"").append(sActionField).append("\">\n");
						
			if (bCreateNew && objlink!=null) {
				if (objlink instanceof ObjectObj) {
					String sClass = request.getParameter(TAGS._class);
					if (sClass != null && sActionField.equals(TAGS._class)) {
						((ObjectObj)objlink).setClass(sClass);
					} else { objlink=null; }
				} else if (objlink instanceof Link) {
					String sLinkType = request.getParameter(TAGS._linktype);
					if (sLinkType != null && sActionField.equals(TAGS._linktype)) {
						((Link)objlink).setLinkType(sLinkType);
					} else { objlink=null; }
				}
			}
			
			// Read the input data
			Vector<Object> formSearchValues = getSearchResults(formHTMLName,session);
			clearSearchResults(formHTMLName,session);
			session.removeAttribute(TAGS.view);
			Object keepFormValues = session.getAttribute(TAGS.keepValues);
			session.removeAttribute(TAGS.keepValues);

			Hashtable<String,String> hInputData;			
			if (formSearchValues != null || bSearched) {
				hInputData = framework.setEnvFromRequest(request, true); 
			} else if (keepFormValues != null || bUpdate || bCreate) {
				hInputData = framework.setEnvFromRequest(request, true);
			} else {
				hInputData = new Hashtable<String,String>();
				framework.emptyEnv();
			}

			// Create the form layout
			sReturn.append("\t  <table ").append(StringUtils.getTagValue(form.getFormat(),TAGS.FORM_Format)).append(">\n");
			sReturn.append("\t\t <tr>\n");

			// Global parameters 		
			String sItemName = "";
			String sRangeField = "";   // List of form-fields for whom is necessary to run the related range program
			String sLoadField = "";    // List of form-fields for whom is necessary to execute the form range program
			String sCheckItems="document."+formHTMLName; // List of items for whom is present a check of input value 

			String sSelectDefaultValue = "";
			if (bSearch && use_search_patterns) {	sSelectDefaultValue = "*";	}
			String section = StringUtils.getTagValue(form.getFormat(), TAGS.FORM_TranslationSection);
			if (section.length() == 0) { section = "*"; }						

			String sCommonSection=(String)session.getAttribute("CommonSection");
			if (sCommonSection==null) { sCommonSection=section; }
			
			boolean bButtons = false;
			boolean bPopUp = false;

			// Compose the form on the basis of current user access rights 
			Vector<FormUserItem> vUserItems = form.getUserItemsWithData( objlink , null,framework );
			int iItemNum = vUserItems.size();
			for (int i=0;i<iItemNum;i++) {
				try {
					FormUserItem fuitem =  vUserItems.elementAt(i);					
					int itemType = fuitem.getType();
					sItemName = fuitem.getName();					
					if (bPrint) fuitem.setEditable(false);	
					sReturn.append(getTD(fuitem, section, framework));

					// Create a rendering for the current item
					switch (itemType) {
					case Item.ITEMTYPE_BASIC:
					case Item.ITEMTYPE_FIELD:
					case Item.ITEMTYPE_XFIELD:
					case Item.ITEMTYPE_ACTION: {
						int iFieldType       = fuitem.getFieldType();
						String sFieldName    = fuitem.getItemValue();
						String sItemFormName = fuitem.getItemFormName();						
						if (itemType == Item.ITEMTYPE_BASIC) {
							sFieldName = "_" + sFieldName;
						}
						// Check if is necessary to compute the field value/ranges
						if (fuitem.getFormat().indexOf(TAGS.FORM_Derived_Values) >= 0) {
							if (fuitem.hasRangeProgram()) {
								if (sRangeField.length() > 0) {	sRangeField += ",";	}
								sRangeField += sFieldName;
							} else {
								if (sLoadField.length() > 0) { sLoadField += ",";	}
								sLoadField += sFieldName;
							}
						}
						
						// Retrieve the item value
						String sDataValue  = (bPreview?getDummyValue(fuitem):fuitem.getValue().getDataValue());
						String sInputValue = hInputData.get(sItemFormName);
						if (sInputValue!=null) {
							sDataValue=sInputValue; 
						} else if (bSearch && use_search_patterns) {
							sDataValue = "*";
						}

						sReturn.append(getLabel(fuitem,section,framework));
						
						if (fuitem.isEditable()) {

							String sOperator = "";
							int iWidth = (int) Math.round(fuitem.getWidth());
							StringTokenizer sOperatorTokenizer = null;
							if (bSearch) {							
								// Comparison operators for dates and numeric filters in a search form
								sOperator = StringUtils.getTagValue(fuitem.getFormat(), TAGS.FORM_SearchOperators);
								sOperatorTokenizer = new StringTokenizer(sOperator, ";");
								if (iFieldType == Item.FIELDTYPE_TEXT || iFieldType == Item.FIELDTYPE_DATE) {
									if (sOperator.length() > 0) {
										iWidth -= 50;
										sReturn.append("\t\t   <table cellpadding=0 cellspacing=4 ><tr><td>\n");
										Vector<String> vOperators = StringUtils.StringTokensToVector(sOperatorTokenizer.nextToken(), ",");
										vOperators.insertElementAt("", 0);
										String sOpValue =  hInputData.get(TAGS.operator + sItemFormName);
										String selectOP1 = addFormSelect(fuitem,sOpValue, vOperators,-1,sPrefix);
										selectOP1=StringUtils.replaceString(selectOP1,TAGS.ELEMENT_ID,TAGS.operator+sItemName);
										selectOP1=StringUtils.replaceString(selectOP1,TAGS.ELEMENT_NAME,TAGS.operator+sItemFormName);
										selectOP1=StringUtils.replaceString(selectOP1,ELEMENT_FORM,formHTMLName);
										sReturn.append(selectOP1);
										sReturn.append("\t\t   </td><td>\n");
										if (sDataValue.equals("*")) {	sDataValue = "";	}										
									}
								}
								sCheckItems += addSearchCheck(fuitem, formHTMLName, section, locale, framework);
							} else {
								sCheckItems += addCheck(fuitem, formHTMLName, section, locale, framework);
							}

							switch (iFieldType) {
							case Item.FIELDTYPE_TEXT:
							case Item.FIELDTYPE_DATE: {
								if ( bCreate || bUpdate || bSearched ) {
									sDataValue = StringUtils.unformatValue(sDataValue, fuitem.getFormat(), locale);
								}
								String text;
								if (iFieldType==Item.FIELDTYPE_DATE) {
									text = addFormDateText(fuitem, StringUtils.formatValue(sDataValue, fuitem.getFormat(), locale), framework.getLanguage(), iWidth, sPrefix,session);
								} else {
									text = addFormText(fuitem, StringUtils.formatValue(sDataValue, fuitem.getFormat(), locale),locale,iWidth,sPrefix);
								}
								text=StringUtils.replaceString(text,TAGS.ELEMENT_ID,sItemName);
								text=StringUtils.replaceString(text,TAGS.ELEMENT_NAME,sItemFormName);
								sReturn.append(text);								
								 // Comparison operators for numeric/date filters in a search form: add the second bound
								if (sOperatorTokenizer!=null && sOperatorTokenizer.hasMoreTokens()) {									
									Vector<String> vOperators = StringUtils.StringTokensToVector(sOperatorTokenizer.nextToken(), ",");
									vOperators.insertElementAt("", 0);
									String sOpValue =  hInputData.get(TAGS.operator + sItemFormName + TAGS._2);
									sReturn.append("\t\t   </td></tr><tr><td>\n");
									String selectOP2 = addFormSelect(fuitem,sOpValue,vOperators,-1,sPrefix);
									selectOP2=StringUtils.replaceString(selectOP2,TAGS.ELEMENT_ID,TAGS.operator+sItemName+TAGS._2);
									selectOP2=StringUtils.replaceString(selectOP2,TAGS.ELEMENT_NAME,TAGS.operator+sItemFormName+TAGS._2);
									selectOP2=StringUtils.replaceString(selectOP2,ELEMENT_FORM,formHTMLName);
									sReturn.append(selectOP2);								
									
									sDataValue =  hInputData.get( sItemFormName + TAGS._2);
									if (sDataValue == null) {	sDataValue = ""; }
									if (bSearched) {
										sDataValue = StringUtils.unformatValue(sDataValue, fuitem.getFormat(), locale);
									}
									sReturn.append("\t\t   </td><td>\n");
									String text2 ;
									if (iFieldType==Item.FIELDTYPE_DATE) {
										text2 = addFormDateText(fuitem, StringUtils.formatValue(sDataValue, fuitem.getFormat(), locale), framework.getLanguage(), iWidth,sPrefix,session);
									} else {
										text2 = addFormText( fuitem, StringUtils.formatValue(sDataValue, fuitem.getFormat(), locale),locale,iWidth,sPrefix);
									}
									text2=StringUtils.replaceString(text2,TAGS.ELEMENT_ID,sItemName+ TAGS._2);
									text2=StringUtils.replaceString(text2,TAGS.ELEMENT_NAME,sItemFormName+ TAGS._2);
									sReturn.append(text2);
								}
								if (sOperator.length()>0) {
									sReturn.append("\t\t   </td></tr></table>\n"); 
								}
							}
							break;

							case Item.FIELDTYPE_TEXTAREA: {
								String textArea = addFormTextArea(fuitem,sDataValue,0,sPrefix);									
								textArea=StringUtils.replaceString(textArea,TAGS.ELEMENT_ID,sItemName);
								textArea=StringUtils.replaceString(textArea,TAGS.ELEMENT_NAME,sItemFormName);
								sReturn.append(textArea);
							}
							break;

							case Item.FIELDTYPE_SELECT:
							case Item.FIELDTYPE_LISTBOX: {
								// Retrieve the range values
								Vector<Object> vValues;
								if (fuitem.getFormat().indexOf(TAGS.FORM_Derived_Values) >= 0) {
									if (sDataValue.indexOf(Field.ATTRSEP) >= 0) {
										vValues = new Vector<Object>(StringUtils.StringTokensToVector(sDataValue, Field.ATTRSEP));
									} else {
										vValues = new Vector<Object>(1);
										vValues.add(sDataValue);
									}
								} else {
									vValues = new Vector<Object>(fuitem.getRanges());		
									vValues.insertElementAt(new FormUserItem.Value(sSelectDefaultValue,sSelectDefaultValue), 0);
								}
								String select;
								if (iFieldType==Item.FIELDTYPE_LISTBOX) {
									select = addFormListBox(fuitem,sDataValue,vValues,0,sPrefix);
								} else {
									select = addFormSelect(fuitem,sDataValue,vValues,0,sPrefix);
								}
								select=StringUtils.replaceString(select,TAGS.ELEMENT_ID,sItemName);
								select=StringUtils.replaceString(select,TAGS.ELEMENT_NAME,sItemFormName);
								select=StringUtils.replaceString(select,ELEMENT_FORM,formHTMLName);
								sReturn.append(select);
							}
							break;

							case Item.FIELDTYPE_CHECKBOX: {
								Vector<FormUserItem.Value> vRanges = fuitem.getRanges();
								int iNumCols = (int)Math.floor(Math.round(fuitem.getWidth())/80);
								sReturn.append("\t\t   <table style=\"width:").append(Math.round(fuitem.getWidth())).append("px\">\n");
								int iCol = 0;
								int iRSize = vRanges.size();
								for (int j = 0; j < iRSize ; j++) {
									if (iCol==iNumCols)  { 
										sReturn.append("\t\t   </tr>\n\t\t   <tr>");  
										iCol=0;
									}
									sReturn.append("\t\t   <td>");
									String check = addFormCheck(fuitem,sDataValue,vRanges.elementAt(j), true,sPrefix);
									check=StringUtils.replaceString(check,TAGS.ELEMENT_ID,sItemName+"_"+j);
									check=StringUtils.replaceString(check,TAGS.ELEMENT_NAME,sItemFormName);
									sReturn.append(check);
									sReturn.append("</td> \n");
									iCol++;
								}
								sReturn.append("\t\t   </tr></table>\n");
							}
							break;

							case Item.FIELDTYPE_RADIO: {
								Vector<FormUserItem.Value> vRanges = fuitem.getRanges();
								int iNumCols = (int)Math.floor(Math.round(fuitem.getWidth())/80);
								sReturn.append("\t\t   <table style=\"width:").append(Math.round(fuitem.getWidth())).append("px\">\n");
								int iCol = 0;
								int iRSize = vRanges.size();
								for (int j = 0; j < iRSize ; j++) {
									if (iCol==iNumCols)  { 
										sReturn.append("\t\t   </tr>\n\t\t   <tr>");  
										iCol=0;
									}
									sReturn.append("\t\t   <td>");									
									String check = addFormCheck(fuitem,sDataValue,vRanges.elementAt(j), false,sPrefix);
									check=StringUtils.replaceString(check,TAGS.ELEMENT_ID,sItemName+"_"+j);
									check=StringUtils.replaceString(check,TAGS.ELEMENT_NAME,sItemFormName);
									sReturn.append(check);
									sReturn.append("</td> \n");
									iCol++;
								}
								sReturn.append("\t\t   </tr></table>\n");
							}
							break;

							case Item.FIELDTYPE_POPUP: {
								String text = addFormPopUpText(fuitem, sDataValue,0,sPrefix,session);
								text=StringUtils.replaceString(text,TAGS.ELEMENT_ID,sItemName);
								text=StringUtils.replaceString(text,TAGS.ELEMENT_NAME,sItemFormName);
								sReturn.append(text);
								bPopUp = true;
							}
							break;

							case Item.FIELDTYPE_HIDDEN: {
								sReturn.append("\t\t   <input type=").append(TAGS.FORM_ControlHidden).append(" id=\"").append(sItemName).append("\"");
								sReturn.append(" name=\"").append(sItemFormName).append("\"");
								sReturn.append(" value=\"").append(sDataValue).append("\"");
								sReturn.append(">\n");
							}
							break;
							}
						} else {
							// Not editable
							if (iFieldType != Item.FIELDTYPE_HIDDEN) {
								if (iFieldType == Item.FIELDTYPE_SELECT || iFieldType == Item.FIELDTYPE_CHECKBOX || iFieldType == Item.FIELDTYPE_RADIO) {
									sReturn.append("\t\t   ").append(HTMLUtil.unescapeHTML(Dictionary.getSubKey(fuitem.getItemValue(), sDataValue, framework))).append("\n");
								} else  {
									String sValue=StringUtils.formatValue(sDataValue,fuitem.getFormat(),locale);
									if (  StringUtils.getTagValue(fuitem.getFormat(),TAGS.FORM_TypeRegExpr).equals(TAGS.FORM_Input_WEB) ) {
										sValue = "<a href=\""+TAGS.PAGE_Url_http+encodeHRef(sValue)+"\" target=_blank>"+sValue+"</a>";
									} else if (  StringUtils.getTagValue(fuitem.getFormat(),TAGS.FORM_TypeRegExpr).equals(TAGS.FORM_Input_EMAIL) ) {
										sValue = "<a href=\""+TAGS.PAGE_Url_mailto+sValue+"\">"+sValue+"</a>";
							        }
									sReturn.append("\t\t   ").append(sValue).append("\n");
								}
							}
							sReturn.append("\t\t   <input type=").append(TAGS.FORM_ControlHidden).append(" id=\"").append(sItemName).append("\"");
							sReturn.append(" name=\"").append(sItemFormName).append("\"");
							sReturn.append(" value=\"").append(sDataValue).append("\"");
							sReturn.append(">\n");
						}
					}
						break;

					case Item.ITEMTYPE_GETOBJ: {
						sReturn.append(getLabel(fuitem,section,framework));
						String sDisplayValue = bPreview?getDummyValue(fuitem):fuitem.getValue().getDisplayValue(); 
						sReturn.append("\t\t   ").append(StringUtils.formatValue(sDisplayValue,fuitem.getFormat(),locale)).append("\n");
					}
						break;

					case Item.ITEMTYPE_GETLINK: {
						sReturn.append(getLabel(fuitem,section,framework));
						String sDisplayValue = bPreview?getDummyValue(fuitem):fuitem.getValue().getDisplayValue();
						sReturn.append("\t\t   ").append(StringUtils.formatValue(sDisplayValue,fuitem.getFormat(),locale)).append("\n");
					}
						break;

					case Item.ITEMTYPE_SECTION: {
						sReturn.append("\t\t   ").append(HTMLUtil.unescapeHTML( fuitem.getValue().getDisplayValue())).append("\n\t\t  </td>\n");
					}
					break;

					case Item.ITEMTYPE_SPACER: {
						if (fuitem.getHeight() > 1) {
							sReturn.append("\t\t </tr>\n");
							sReturn.append("\t\t <tr height=").append(Math.round(fuitem.getHeight())).append(">");
						} 
						sReturn.append("\t\t </tr>\n");
						sReturn.append("\t\t <tr>\n");
					}
					break;

					case Item.ITEMTYPE_HREF: {
						sReturn.append(addFormHRef(fuitem));
					}
					break;

					case Item.ITEMTYPE_LABEL: {
						sReturn.append("\t\t   <span class=label width=").append(Math.round(fuitem.getWidth())).append(">");
						sReturn.append("<font ").append(StringUtils.getTagValue(fuitem.getFormat(),TAGS.FORM_Format)).append(" >").append(Dictionary.getKey(section,fuitem.getItemValue(),framework)).append("</font></span>\n");

					}  
					break;

					case Item.ITEMTYPE_IMAGE: {
						sReturn.append(addFormImage(fuitem, fuitem.getValue().getDataValue()));
					}
					break;

					case Item.ITEMTYPE_EMBED: {
						sReturn.append(addFormObject(fuitem, fuitem.getValue().getDataValue()));
					}
					break;

					case Item.ITEMTYPE_HIDDEN: {
						sReturn.append("\t\t   <input type=").append(TAGS.FORM_ControlHidden).append(" id=\"").append(sItemName).append("\"");
						sReturn.append(" name=\"").append(sItemName).append("\"");
						sReturn.append(" value=\"").append(fuitem.getItemValue()).append("\">\n");
						if (fuitem.getFormat().indexOf(TAGS.FORM_Derived_Values) >= 0) {
							if (sLoadField.length() > 0) { sLoadField += ",";	}
							sLoadField += sItemName;
						}
					}
					break;

					case Item.ITEMTYPE_BUTTON: {
						String sExpression = fuitem.getItemValue();
						if (!sExpression.equals(TAGS.FORM_ButtonBarStart) && !sExpression.equals(TAGS.FORM_ButtonBarEnd) && !bPrint) {
							if (!sExpression.equals(TAGS.FORM_ButtonPrevNext)) {
								boolean bSubmitButton = fuitem.getFormat().indexOf(TAGS.FORM_Reload_Items) >= 0;
								if (fuitem.isEditable() || !bSubmitButton) {
									sReturn.append("\t\t   <input type=").append((bSubmitButton?TAGS.FORM_ControlSubmit : TAGS.FORM_ControlButton)).append(" id=\"").append(sItemName).append("\"");
									sReturn.append(" name=\"").append(sItemName).append("\"");
									sReturn.append(" value=\"").append(HTMLUtil.unescapeHTML(fuitem.getValue().getDisplayValue())).append("\" ");
									sReturn.append(encodeHRef(fuitem.getValue().getDataValue())).append(" >\n");
								}
							} else if (request.getParameter(TAGS.popup) == null) {
								Vector<String> vSequence = (Vector<String>) session.getAttribute(TAGS.sequence);
								if (vSequence != null) {
									int iPos = -1;
									for (int si = 0; si < vSequence.size(); si++) {
										if (( vSequence.elementAt(si)).equals(sID)) {
											iPos = si;
										}
									}
									if (iPos > 0) {
									    StringTokenizer sTC = new StringTokenizer(vSequence.elementAt(iPos-1),"|"); sTC.nextToken(); 
										sReturn.append("\t\t   <a href=\"").append(TAGS.PAGE_Edit).append("?").append(TAGS.id).append("=").append(encodeURL(sTC.nextToken()))
											.append("\"><img src=\"").append(getRootPath(session))
											.append("common/images/prev.png\" border=0 style=\"vertical-align:middle;\"></a>");
									}
									if (iPos >= 0 && iPos < vSequence.size() - 1) {
									    StringTokenizer sTC = new StringTokenizer(vSequence.elementAt(iPos+1),"|"); sTC.nextToken(); 
										sReturn.append("\t\t   <a href=\"").append(TAGS.PAGE_Edit).append("?").append(TAGS.id).append("=").append(encodeURL(sTC.nextToken()))
											.append("\"><img src=\"").append(getRootPath(session))
											.append("common/images/next.png\" border=0 style=\"vertical-align:middle;\"></a>");
									}
								}
							}
						} 
					}
					break;

					case Item.ITEMTYPE_NAVIGATE: {
						if (bPreview || !bCreateNew && !bSearch && (objlink!=null && objlink instanceof ObjectObj)) {
							sReturn.append("\t\t   <table cellspacing=1 border=0 ");
							sReturn.append(fuitem.getWidth()>0?" width="+Math.round(fuitem.getWidth()):"width=100% ");
							sReturn.append(fuitem.getHeight()>0?" height="+Math.round(fuitem.getHeight()):"");
							sReturn.append(">\n");	
							boolean show_object_class = getAppParam(TAGS.APP_show_object_class).equalsIgnoreCase("true");
							bPopUp = true;
							try {
								String sCommand = "object navigate " + sID + " " + fuitem.getItemValue() + " token '"+Application.sToken+"';";
								sCommand = StringUtils.replaceString(sCommand, "<GET>", "get { id }");
								sCommand = StringUtils.replaceString(sCommand, "<GETLINK>", "getlink { id }");
								Vector<String> navobjs = (bPreview?new Vector<String>():StringUtils.StringTokensToVector(JLClient.performOOQLCommands(sCommand,framework).elementAt(0),"\n"));								
								int kSize=navobjs.size();
								Vector<String[]> navObjects = new Vector<String[]>(kSize);
								Vector<Object> ids = new Vector<Object>(kSize);
								for (int k=0;k<kSize;k++) {
									String[] vObj = StringUtils.StringTokensToArray(navobjs.elementAt(k),Application.sToken);
									navObjects.add(vObj);
									ids.add(new String[]{vObj[6],vObj[7]});
								}
								String sView = StringUtils.getTagValue(fuitem.getFormat(), TAGS.FORM_Format);
								sReturn.append("<tr class=tableheader><td colspan=").append((show_object_class?2:1)).append("></td>");
								int iSpan = 3;
								Vector<ViewUserColumn> vColumns = null;
								if (sView.length() > 0) {
									View view = View.open(sView,framework.getUserName(),framework);
									String viewsection = StringUtils.getTagValue(view.getFormat(), TAGS.FORM_TranslationSection);
									if (viewsection.length() == 0) {
										viewsection = getAppParam(TAGS.APP_dictionary_section);
									}
									vColumns = view.getUserColumnsWithData( ids, null, framework);
									int iSize=vColumns.size();
									iSpan += iSize;
									for (int ii = 0; ii < iSize; ii++) {
										ViewUserColumn column = vColumns.elementAt(ii);
										sReturn.append("<td>").append(HTMLUtil.unescapeHTML(Dictionary.getKey(viewsection,column.getLabel(),framework))).append("</td>");
									}
								}
								sReturn.append("</tr>\n");
							
								Vector<String> vButtons = getActionButtons(fuitem);
								String sOpenURL = "";
								String sOpenPopStyle = null;
								for (int bn = 0; bn < vButtons.size(); bn++) {
									String sButton =  vButtons.elementAt(bn);
									if (sButton.startsWith(TAGS.FORM_ButtonOpen)) { // Open object
										StringTokenizer sT = new StringTokenizer(sButton, ":");
										sT.nextToken();
										sOpenURL = sT.nextToken();
										if (sT.hasMoreTokens()) {
											sOpenPopStyle = sT.nextToken();
										}
										break;
									}
								}
							
								String sRowClass="dark";
								int iSize=navobjs.size();
								ViewUserColumn.Value sValue;
								for (int kl=0;kl<iSize;kl++) {
									String[] vObj = navObjects.elementAt(kl);
									sRowClass=switchRowclass(sRowClass);
									String sClass    = vObj[3];
									String sName     = vObj[4];
									String sRevision = vObj[5];
									String sId	     = vObj[6];
									String sLinkId	 = vObj[7];
									sReturn.append("<tr class=").append(sRowClass).append(">");
									sReturn.append("<td><nobr>");
									if (fuitem.isEditable()) {
										sReturn.append("<input type=").append(TAGS.FORM_ControlCheckbox).append(" name=\"").append(sItemName).append("_").append(kl).append("\" value=\"").append(sId).append("/").append(sLinkId).append("\">&nbsp;");							
									}						
									sReturn.append(drawClassIcon(sClass,session)).append("&nbsp;");
									if (show_object_class) {
										sReturn.append(Dictionary.getKey(section,sClass,framework)).append("</nobr></td><td>");
									}
									if ( sOpenURL.equals("") ) {
										sReturn.append("<b>").append(sName).append("</b>");
									} else {
										if (sOpenPopStyle==null) {	
											sReturn.append("<a href=\"").append(sOpenURL).append("?").append(TAGS.id).append("=").append(encodeURL(sId)).append("&tx=").append(System.currentTimeMillis()).append("\" target=_blank><b>").append(sName).append("</b></a>");
										} else {
											bPopUp = true;
											sReturn.append("<a href=\"javascript:do").append(sPrefix).append("Open('").append(sItemName).append("','").append(sOpenURL).append((sOpenURL.indexOf('?')>0?"&":"?")).append(TAGS.id).append("=").append(sId).append("','").append(sOpenPopStyle.replace(';',',')).append("')\"><b>").append(sName).append("</b></a>");
										} 
									}
									if (sRevision.length() > 0 && !sRevision.equals("-")) {
										sReturn.append(name_revision_separator).append(sRevision);
									}
									sReturn.append("</td>");
									if (vColumns != null) {
										int iColSize=vColumns.size();
										for (int ii = 0; ii < iColSize; ii++) {
											ViewUserColumn column = vColumns.elementAt(ii);
											sValue=column.getValues()[kl];
											sReturn.append("<td>").append(HTMLUtil.unescapeHTML(sValue.getDisplayValue())).append("</td>");
										}
									}
									sReturn.append("</tr>\n");
								}
								if (fuitem.isEditable()) {
									if (vButtons.size() > 0) {
										sReturn.append("<tr class=tableheader><td heigth=2 colspan=").append(iSpan).append("></td></tr><tr><td colspan=").append(iSpan).append(" align=right><nobr>\n");
										for (int bn = 0; bn < vButtons.size(); bn++) {
											String sButton =  vButtons.elementAt(bn);
											if (sButton.equals(TAGS.FORM_ButtonRemove)) { // Remove object
												sReturn.append("&nbsp;<a href=\"javascript:do").append(sPrefix).append("Remove('").append(sItemName).append("')\">").append(getHTMLIcon("iconRem.gif")).append("&nbsp;").append(Dictionary.getKey(sCommonSection,"Remove",framework)).append("</a>\n");
												bButtons=true;							  
											} else if (sButton.equals(TAGS.FORM_ButtonErase)) { // Erase object
												sReturn.append("&nbsp;<a href=\"javascript:do").append(sPrefix).append("Erase('").append(sItemName).append("')\">").append(getHTMLIcon("iconDel.gif")).append("&nbsp;").append(Dictionary.getKey(sCommonSection,"Erase",framework)).append("</a>\n");
												bButtons=true;
											} else if (sButton.startsWith(TAGS.FORM_ButtonAdd)) { // Add object
												StringTokenizer sT = new StringTokenizer(sButton, ":");
												sT.nextToken();
												bButtons=true;
												sReturn.append("&nbsp;<a href=\"javascript:do").append(sPrefix).append("Add('").append(sItemName).append("','").append((sT.hasMoreTokens()?sT.nextToken():"")).append("','").append((sT.hasMoreTokens()?sT.nextToken():"")).append("')\">").append(getHTMLIcon("iconAdd.gif")).append("&nbsp;").append(Dictionary.getKey(sCommonSection,"Add",framework)).append("</a>\n");
											} else if (sButton.startsWith(TAGS.FORM_ButtonNew)) { // New object
												StringTokenizer sT = new StringTokenizer(sButton, ":");
												sT.nextToken();
												bButtons=true;
												sReturn.append("&nbsp;<a href=\"javascript:do").append(sPrefix).append("New('").append(sItemName).append("','").append((sT.hasMoreTokens()?sT.nextToken():"")).append("','").append((sT.hasMoreTokens()?sT.nextToken():"")).append("')\">").append(getHTMLIcon("iconNew.gif")).append("&nbsp;").append(Dictionary.getKey(sCommonSection,"New",framework)).append("</a>\n");
											}
											sReturn.append("&nbsp;");
										}
										sReturn.append("</nobr></td></tr>\n");
									}	
								}
							} catch (Exception ex) {
								sReturn.append("<tr><td><font color=red>").append(ex.getMessage()).append("</font></td><tr>");
							}
							sReturn.append("\t\t   </table>\n");
						}
						
					}
						break;
					}
					if (fuitem.getUnitMeasure().length()>0) {
						sReturn.append("<nobr><b>&nbsp;"+fuitem.getUnitMeasure()+"</b></nobr>");
					}
					sReturn.append(getEndTD(fuitem));
				} catch (Exception e) {
					return "Item "+sItemName+" Exception: "+e.getMessage(); 
				} catch (Error e) {
					return "Item "+sItemName+" Error: "+e.getMessage(); 
				}
			}  
			sReturn.append("\t\t </tr>\n");
			sReturn.append("\t  </table>\n\n");

			if (!bPrint) {
				sReturn.append("\t </FORM>\n");
				sReturn.append("   <script language=javascript >\n");
				sReturn.append("\tfunction check").append(sPrefix).append("Fields() {\n");
				sReturn.append("\t try {\n");
				sReturn.append("\t  if (").append(sCheckItems).append(") {  \n");
				if (form.getCheckProgram().equals("")) { 
					sReturn.append("\t    return true;\n");	
				} else {     
					sReturn.append("\t    submitRequest('").append(formHTMLName).append("','").append(formName).append("');\n");
				} 
				sReturn.append("\t  }\n");  
				sReturn.append("\t  return false;\n");
				sReturn.append("\t } catch (ex) { return false; }\n");
				sReturn.append("\t}\n\n");
				sReturn.append("\tfunction refresh").append(sPrefix).append("Fields(field) {\n");
				sReturn.append("\t  refreshFieldData('").append(formHTMLName).append("','").append(formName).append("','").append(sRangeField).append("','").append(sLoadField).append("', field);\n"); 
				sReturn.append("\t}\n\n");
				sReturn.append("\tfunction refresh").append(sPrefix).append("Page(field) {\n");
				sReturn.append("\t  refreshFormPage('").append(formHTMLName).append("','").append(bSearch?TAGS.search:TAGS.update).append("', field );\n"); 
				sReturn.append("\t}\n\n");    
				if (bButtons) {
					sReturn.append("\tfunction do").append(sPrefix).append("Remove(tabName) {\n");
					sReturn.append("\t  doObjectUnLink('").append(sID).append("',document.forms['").append( formHTMLName).append("'],tabName,'").append(Dictionary.getKey(sCommonSection,"MSG_SelectAtLeastOneObject",framework)).append("','").append(Dictionary.getKey(sCommonSection,"MSG_EraseSelectedObjectsMessage",framework)).append("?' );\n");
					sReturn.append("\t}\n\n");
					sReturn.append("\tfunction do").append(sPrefix).append("Erase(tabName) {\n");
					sReturn.append("\t  doObjectErase('").append(sID).append("',document.forms['").append( formHTMLName).append("'],tabName,'").append(Dictionary.getKey(sCommonSection,"MSG_SelectAtLeastOneObject",framework)).append("','").append(Dictionary.getKey(sCommonSection,"MSG_EraseSelectedObjectsMessage",framework)).append("?' );\n");
					sReturn.append("\t}\n\n");
					sReturn.append("\tfunction do").append(sPrefix).append("Add(tabName,pageUrl,popProp) {\n");
					sReturn.append("\t  if (popProp=='') { popProp='location=no,menubar=no,titlebar=no,status=yes,width=900,height=500,resizable=yes,scrollbars=yes'; } \n");
					sReturn.append("\t  window.open(pageUrl+'&").append(TAGS.id).append("=").append(encodeURL(sID)).append("&").append(TAGS.fwd).append("=").append(actionPage).append("'").append(",'Add_").append( formHTMLName).append("',popProp);\n");  
					sReturn.append("\t}\n\n");
					sReturn.append("\tfunction do").append(sPrefix).append("New(tabName,pageUrl,popProp) {\n");
					sReturn.append("\t  var d = new Date();\n"); 
					sReturn.append("\t  pageUrl=pageUrl.replace(/;/g,'%59')+'%59").append(encodeURL(sID)).append("&tx='+d.getMilliseconds()+'&").append(TAGS.create).append("=true&").append(TAGS.id).append("=").append(encodeURL(sID)).append("';\n");
					sReturn.append("\t  if (popProp=='') { popProp='location=no,menubar=no,titlebar=no,status=yes,width=900,height=600,resizable=yes,scrollbars=yes'; } else { pageUrl+='&").append(TAGS.popup).append("=true'; } \n");
					sReturn.append("\t  if (popProp.indexOf('").append(TAGS.inline).append("=yes')<0) { \n");
					sReturn.append("\t    window.open(pageUrl.replace(/%59/g,';'),'New_").append( formHTMLName).append("',popProp.replace(/;/g,','));\n"); 
					sReturn.append("\t  } else { showPopUp(pageUrl+'&").append(TAGS.inline).append("=true',popProp.replace(/;/g,','),''); } \n");
					sReturn.append("\t}\n\n");
				}
				if (bPopUp) {
					sReturn.append("\tfunction do").append(sPrefix).append("Open(tabName,pageUrl,popProp) {\n");
					sReturn.append("\t  var d = new Date();\n");
					sReturn.append("\t  pageUrl+='&tx='+d.getMilliseconds();\n");
					sReturn.append("\t  if (popProp=='') { popProp='location=no,menubar=no,titlebar=no,status=yes,width=900,height=500,resizable=yes,scrollbars=yes'; } else { pageUrl+='&").append(TAGS.popup).append("=true'; } \n");
					sReturn.append("\t  if (popProp.indexOf('").append(TAGS.inline).append("=yes')<0) { \n");
					sReturn.append("\t     window.open(pageUrl.replace(/#/g,'%23'),'Open_").append( formHTMLName).append("',popProp);\n");
					sReturn.append("\t  } else { showPopUp(pageUrl.replace(/#/g,'%23'),popProp,''); } \n");
					sReturn.append("\t}\n\n");    	
				}        

				if (sPrefix.length()==0) {
				 sReturn.append("\tsetLanguage('").append(framework.getLanguage()).append("');\n\n");
				 sReturn.append("\tcheckmessages['Empty']=\"").append(Dictionary.getKey(sCommonSection,"MSG_EmptyField",framework)).append("\";\n");
				 sReturn.append("\tcheckmessages['Ignored']=\"").append(Dictionary.getKey(sCommonSection,"MSG_IgnoredField",framework)).append("\";\n");
				 sReturn.append("\tcheckmessages['Unselected']=\"").append(Dictionary.getKey(sCommonSection,"MSG_UnselectField",framework)).append("\";\n");
				 sReturn.append("\tcheckmessages['InvalidDate']=\"").append(Dictionary.getKey(sCommonSection,"MSG_InvalidDate",framework)).append("\";\n");
				 sReturn.append("\tcheckmessages['InvalidDateFormat']=\"").append(Dictionary.getKey(sCommonSection,"MSG_InvalidDateFormat",framework)).append("\";\n");
				 sReturn.append("\tcheckmessages['InvalidFloat']=\"").append(Dictionary.getKey(sCommonSection,"MSG_InvalidFloat",framework)).append("\";\n");
				 sReturn.append("\tcheckmessages['InvalidInteger']=\"").append(Dictionary.getKey(sCommonSection,"MSG_InvalidInteger",framework)).append("\";\n");
				 sReturn.append("\tcheckmessages['TooShortString']=\"").append(Dictionary.getKey(sCommonSection,"MSG_TooShortString",framework)).append("\";\n");
				 sReturn.append("\tcheckmessages['TooLongString']=\"").append(Dictionary.getKey(sCommonSection,"MSG_TooLongString",framework)).append("\";\n");				 
				 sReturn.append("\tcheckmessages['InvalidFieldFormat']=\"").append(Dictionary.getKey(sCommonSection,"MSG_InvalidFieldFormat",framework)).append("\";\n");
				}
				sReturn.append("\trefresh").append(sPrefix).append("Fields('").append(request.getParameter(TAGS.activefield)).append("');\n\n");    
				sReturn.append("   </script>\n");

				if (bPopUp) { 	sReturn.append(addPopUpDiv(session));  }
			}
		} catch (Exception exx) {
			return "Form '"+formName+"' Exception: "+exx.getMessage(); 
		} catch (Error exx) {
			return "Form '"+formName+"' Error: "+exx.getMessage(); 
		}
		return sReturn.toString();
	}

	private static String addPopUpDiv(HttpSession session) {
		String sDiv="<div id=\"dwindow\" class=PopUpWindow style=\"position:absolute;left:0px;top:0px;display:none;z-index:10000;\" onMousedown=\"initializedrag(event)\" onMouseup=\"stopdrag()\" onSelectStart=\"return false\">\n";
		sDiv+="<div><img src=\""+getRootPath(session)+"common/images/max.gif\" id=\"maxname\" onClick=\"maximize()\"><img src=\""+getRootPath(session)+"common/images/close.gif\" onClick=\"closeit()\"></div>\n";
		sDiv+="<div id=\"dwindowcontent\" ><iframe id=\"cframe\" src=\"\" width=\"100%\" height=\"100%\"></iframe></div>\n</div>\n";

		return sDiv;
	}

	public static String saveFormData(String forwardPage, ObjectBase objlink, Form form, ApplicationRequest request) throws Exception {
		if (objlink instanceof ObjectObj) {
			return saveObjectFormData(forwardPage, (ObjectObj) objlink, form, request);
		} else if (objlink instanceof Link) {
			return saveLinkFormData(forwardPage, (Link) objlink, form, request);
		} else {
			return "";
		}
	}

	private static String saveObjectFormData(String forwardPage, ObjectObj object, Form form, ApplicationRequest request) throws Exception {
		HttpSession session = request.getSession();
		Framework framework = Application.getFramework(session);
		boolean bPreview = (request.getParameter(TAGS.preview) != null);
		String srUpdate = request.getParameter(TAGS.update);
		if (srUpdate != null && srUpdate.equals("true")) {
			// System.out.println("UPDATE "+request);
			boolean bCreateNew = true;
			if (object == null) {
				return "";
			}
			if (form == null) {
				return "";
			}
			String sID = object.getID();
			if (sID.length() > 0) {
				bCreateNew = false;
			}
			try {
				Locale locale = new Locale(translateOberonLanguageToISO639Language(framework.getLanguage(),session));
				object.setLinked(true);
				object.resetChanges();
				if (bCreateNew) {
					String sBasic = request.getParameter(TAGS._class);
					if (sBasic != null)
						object.setClass(sBasic);
					sBasic = request.getParameter(TAGS._name);
					if (sBasic != null)
						object.setName(sBasic);
					sBasic = request.getParameter(TAGS._revision);
					if (sBasic != null)
						object.setRevision(sBasic);
					sBasic = request.getParameter(TAGS._lifecycle);
					if (sBasic != null)
						object.setLifecycle(sBasic);
					sBasic = request.getParameter(TAGS._objectspace);
					if (sBasic != null)
						object.setObjectSpace(sBasic);
					sBasic = request.getParameter(TAGS._description);
					if (sBasic != null)
						object.setDescription(sBasic);
					sBasic = request.getParameter(TAGS._holder);
					if (sBasic != null)
						object.setHolder(sBasic);
					sBasic = request.getParameter(TAGS._locker);
					if (sBasic != null)
						object.setLocker(sBasic);
					sBasic = request.getParameter(TAGS._currentstage);
					if (sBasic != null)
						object.setStage(sBasic);
				} else {
					String sBasic = request.getParameter(TAGS._description);
					if (sBasic != null)
						object.setDescription(sBasic);
				}
				// Get Form Fields
				Vector<FormUserItem> vFields = form.getUserFieldItems(object, null, framework);
				// Extract the list of field names
				int iItemNum = vFields.size();
				Vector<String> vFieldNames = new Vector<String>(iItemNum);
				for (int i = 0; i < iItemNum; i++) {
					FormUserItem fuitem =  vFields.elementAt(i);
					vFieldNames.add(fuitem.getItemFormName());
				}
				// Assign the value of input parameters for the Object-Fields
				for (Enumeration<String> en = request.getParameterNames(); en.hasMoreElements();) {
					String nameP  =  en.nextElement();
					if (nameP.endsWith("[]")) {
						nameP = nameP.substring(0, nameP.length() - 2);
					}
					int iFieldPos = vFieldNames.indexOf(nameP);
					if (iFieldPos >= 0) { // The input parameter is an Object-Field
						String valueP = "";
						String[] valueMulti = request.getParameterValues(nameP);
						for (int i=0;i<valueMulti.length;i++) {
							if (i==0) { valueP = ""; } else { valueP += Field.ATTRSEP ; }
							valueP += valueMulti[i];
						}
						FormUserItem fuitem =  vFields.elementAt(iFieldPos);
						if (fuitem != null && (fuitem.getFieldType() == Item.FIELDTYPE_DATE || fuitem.getFieldType() == Item.FIELDTYPE_TEXT)) {
							valueP = StringUtils.unformatValue(valueP, fuitem.getFormat(), locale);
						}
						// System.out.println(nameP+"="+valueP+"<br>");
						object.setFieldValue(fuitem.getItemValue(), valueP);
					}
				}
				if (bPreview) {
					if (bCreateNew && request.getParameter(TAGS.autoname) != null) {
						return object.getAutoCreateCommand(request.getParameter(TAGS.autoname));
					} else {
						if (request.getParameter(TAGS._class) == null ) { object.setID("#00000-12345678"); }
						return object.getSaveCommand();
					}
				} else {
					// Create / Update the Object
					if (bCreateNew && request.getParameter(TAGS.autoname) != null) {
						object.autocreate(request.getParameter(TAGS.autoname),framework);
					} else if (bCreateNew) {
						object.create(framework);
					} else {
						object.write(framework);
					}
					String popup = "";
					if (request.getParameter(TAGS.popup)!=null) {
						popup="&"+TAGS.popup+"=true";
					}
					if (bCreateNew) {
						sID = object.getID();
						// Perform the form action program
						doAction(form, sID, request);
						if (request.getParameter(TAGS.FORM_ActionLink) == null) {
							if (request.getParameter(TAGS.dorefresh) != null) {
								return getRootPath(session)+"common/"+TAGS.PAGE_DoWork+"?"+TAGS.id+"="+encodeURL(sID)+"&"+TAGS.close+"=true"+popup;
							} else if (forwardPage.length() > 0) {
								return forwardPage+"?"+TAGS.id+"="+encodeURL(sID)+"&"+TAGS.form+"="+popup;
							}
						} else {
							// Connect the new object with the reference object 
							String[] vLink = StringUtils.StringTokensToArray(request.getParameter(TAGS.FORM_ActionLink), ";");
							if (vLink.length == 3) {
								return getRootPath(session)+"common/"+TAGS.PAGE_DoWork+"?"									
									+TAGS.id+"="+encodeURL(vLink[2])+"&"
									+TAGS.action+"="+TAGS.FORM_ActionLink+"&"
									+TAGS.linktype+"="+vLink[1]+"&"
									+TAGS.versus+"="+vLink[0]+"&"
									+TAGS.list+"="+encodeURL(sID)+"&"
								    +TAGS.close+"=true"+popup
									+(request.getParameter(TAGS.inline)!=null?"&"+TAGS.inline+"=true":"");
							} else {
								return forwardPage+"?"+TAGS.id+"="+encodeURL(sID)+"&"+TAGS.form+"="+popup;
							}
						}
					} else {
					  // Perform only the form action program
						doAction(form, null, request);
						if (request.getParameter(TAGS.dorefresh) != null) {
							return getRootPath(session)+"common/"+TAGS.PAGE_DoWork+"?"
								+TAGS.id+"="+encodeURL(sID)+"&"
								+TAGS.close+"=true"+popup
								+(request.getParameter(TAGS.inline)!=null?"&"+TAGS.inline+"=true":"");
						} else if (forwardPage.length() > 0) {
							return forwardPage+"?"+TAGS.id+"="+encodeURL(sID)+"&"+TAGS.form+"="+popup;
						}
					}
				}
			} catch (Exception e) {
				setErrorMessage(session,StringUtils.replaceString(e.getMessage(),"\n","<br>"));
				session.setAttribute(TAGS.keepValues,"true");
			}
		}
		return "";
	}

	private static String saveLinkFormData(String forwardPage, Link link, Form form, ApplicationRequest request) throws Exception {
		HttpSession session = request.getSession();
		Framework framework = Application.getFramework(session);
		String srUpdate = request.getParameter(TAGS.update);
		if (srUpdate != null && srUpdate.equals("true")) {
			if (link == null) {
				return "";
			}
			if (form == null) {
				return "";
			}
			String sID = link.getID();
			try {
				link.setLinked(true);
				link.resetChanges();
				Locale locale = new Locale(translateOberonLanguageToISO639Language(framework.getLanguage(),session));
 			  // Get Form Fields
				Vector<FormUserItem> vFields = form.getUserFieldItems(link, null, framework);
		  	// Extract the list of field names
				int iSize = vFields.size();
				Vector<String> vFieldNames = new Vector<String>(iSize);
				for (int i = 0; i < iSize; i++) {
					FormUserItem fuitem =  vFields.elementAt(i);
					vFieldNames.add(fuitem.getItemFormName());
				}				
			  // Assign the value of input parameters for the Link Fields
				for (Enumeration<String> en = request.getParameterNames(); en.hasMoreElements();) {
					String nameP  =  en.nextElement();
					int iFieldPos = vFieldNames.indexOf(nameP);
					if (iFieldPos >= 0) { // The input parameter is a Link-Field
						String valueP = "";
						String[] valueMulti = request.getParameterValues(nameP);
						for (int i=0;i<valueMulti.length;i++) {
							if (i==0) { valueP = ""; } else { valueP += Field.ATTRSEP ; }
							valueP += valueMulti[i];
						}
						if (nameP.endsWith("[]")) { 
							nameP=nameP.substring(0,nameP.length()-2);
						}
						FormUserItem fuitem =  vFields.elementAt(iFieldPos);
						if (fuitem != null && (fuitem.getFieldType() == Item.FIELDTYPE_DATE || fuitem.getFieldType() == Item.FIELDTYPE_TEXT)) {
							valueP = StringUtils.unformatValue(valueP, fuitem.getFormat(), locale);
						}
						// System.out.println(nameP+"="+valueP);
						link.setFieldValue(fuitem.getItemValue(), valueP);
					}
				}
			  // Create / Update the Link
				link.write(framework);
				// Perform the form action program
				doAction(form, null, request);
				String popup = "";
				if (request.getParameter(TAGS.popup)!=null) {
					popup="&"+TAGS.popup+"=true";
				}
				if (request.getParameter(TAGS.dorefresh) != null) {
					return getRootPath(session)+"common/"+TAGS.PAGE_DoWork+"?"+TAGS.close+"=true&"
							+TAGS.id+"="+encodeURL(sID)+popup
							+(request.getParameter(TAGS.inline)!=null?"&"+TAGS.inline+"=true":"");
				} else if (forwardPage.length() > 0) {
					return forwardPage + "?"+TAGS.id+"="+encodeURL(sID)+"&"+TAGS.form+"="+popup;
				}
			} catch (Exception e) {
				setErrorMessage(session,StringUtils.replaceString(e.getMessage(),"\n","<br>"));
				session.setAttribute(TAGS.keepValues, "true");
			}
		}
		return "";
	}

	private static void doAction(Form form, String sID, ApplicationRequest request) throws Exception {
		if (form == null) {
			return;
		}
		String sActionProgram = form.getActionProgram().trim();
		if (sActionProgram.length() > 0) {
			Framework framework = Application.getFramework(request.getSession());
			framework.setEnvFromRequest(request, false);
			framework.setEnv(Arg.ACTION, sActionProgram);
			if (sID != null) framework.setEnv(TAGS.id, sID);
			framework = form.action(framework, new Vector<Object>(0));
		}
	}

	public static String searchObjects(Form form, ApplicationRequest request) throws Exception {
		if (form == null) {
			return "";
		}		
		boolean bPreview = (request.getParameter(TAGS.preview) != null);
		HttpSession session = request.getSession();
		Framework framework = Application.getFramework(session);
		String formHTMLName = getFormHTMLName(form);		
		String sReturn = "";
		if (getSearchResults(formHTMLName,session) == null && request.getParameter(TAGS.search) != null) {				
			String sClass = "*";
			String sName = "*";
			String sRevision = "*";
			String sDescription = "*";
			String sHolder = "*";
			String sLifecycle = "*";
			String sStage = "*";
			String sLocker = "*";
			String sObjectSpace = "*";
			String sLimit = request.getParameter(TAGS.maxitems);
			if (sLimit == null) {
				sLimit = "100000";
			}			
			Locale locale = new Locale(translateOberonLanguageToISO639Language(framework.getLanguage(),session));
			String[] valueMulti = null;
			String valueP = "";
			String sFilter = "";
			String sOperator = "";
			Vector<FormUserItem> vFields = form.getUserFieldItems(null, null, framework);
			int iSize = vFields.size();
			Vector<String> vFieldNames = new Vector<String>(iSize);
			for (int i = 0; i < iSize; i++) {
				FormUserItem fuitem = vFields.elementAt(i);
				vFieldNames.add(fuitem.getItemFormName());
			}
			for (Enumeration<String> en = request.getParameterNames(); en.hasMoreElements();) {
				String nameP = en.nextElement();
				valueMulti = request.getParameterValues(nameP);
				for (int i = 0; i < valueMulti.length; i++) {
					if (i == 0) { valueP = "";	} else { valueP += Field.ATTRSEP;	}
					valueP += valueMulti[i];
				}
				if (nameP.endsWith("[]")) {
					nameP = nameP.substring(0, nameP.length() - 2);
				}
				if (!use_search_patterns && valueP.length() == 0) {
					valueP = "*";
				}
				int iFieldPos = vFieldNames.indexOf(nameP);
				if (iFieldPos >= 0) {
					FormUserItem fuitem =  vFields.elementAt(iFieldPos);
					String sFieldName = fuitem.getItemValue();
					boolean bUseOperator = true;
					if (fuitem.getFieldType() == Item.FIELDTYPE_DATE || fuitem.getFieldType() == Item.FIELDTYPE_TEXT) {
						valueP = StringUtils.unformatValue(valueP, fuitem.getFormat(), locale);
					}
					sOperator = request.getParameter(TAGS.operator + nameP);
					if (sOperator == null) {
						bUseOperator = false;
						sOperator = "";
					}
					if (sOperator.length() == 0 && valueP.length() > 0) {
						sOperator = "==";
					}
					boolean isNumber = (fuitem.getFormat().indexOf("<"+TAGS.FORM_TypeReal+"[") >= 0 
							|| fuitem.getFormat().indexOf("<"+TAGS.FORM_TypeInteger+"[") >= 0);
					if (isNumber && valueP.length() == 0) {
						sOperator = "";
					}

					if (!bUseOperator && !use_search_patterns && !valueP.equals("*")
							&& (fuitem.getFieldType() == Item.FIELDTYPE_TEXT || fuitem.getFieldType() == Item.FIELDTYPE_POPUP)) {
						valueP += "*";
					}
					//System.out.println(nameP+"="+valueP+"<br>");

					if (valueP.indexOf(Field.ATTRSEP) < 0) {
						if (valueP.indexOf("?") < 0 && valueP.indexOf("*") < 0) {
							// Simple value without wildcards
							if (sOperator.length() > 0) {
								if (!sFilter.equals("")) {
									sFilter += " &&";
								}
								sFilter += " field['" + sFieldName + "'] " + sOperator + " '" + valueP + "'";
							}
							sOperator = request.getParameter(TAGS.operator + nameP + TAGS._2);
							if (sOperator != null && sOperator.length() > 0) {
								if (!sFilter.equals("")) {
									sFilter += " &&";
								}
								valueP = request.getParameter(nameP + TAGS._2);
								if (fuitem.getFieldType() == Item.FIELDTYPE_DATE || fuitem.getFieldType() == Item.FIELDTYPE_TEXT) {
									valueP = StringUtils.unformatValue(valueP, fuitem.getFormat(), locale);
								}
								sFilter += " field['" + sFieldName + "'] " + sOperator + " '" + valueP + "'";
							}
						} else if (!valueP.equals("*")) {
							// Simple Pattern
							if (!sFilter.equals("")) {
								sFilter += " &&";
							}
							sFilter += " field['" + sFieldName + "'] ~~ '" + valueP + "'";
						}
					} else {
						// Multiple values
						if (!sFilter.equals("")) {
							sFilter += " &&";
						}
						String[] vValue = StringUtils.StringTokensToArray(valueP, Field.ATTRSEP);
						sFilter += " (";
						for (int k = 0; k < vValue.length; k++) {
							if (k > 0) {
								sFilter += " ||";
							}
							String valuePk = vValue[k];
							if (valuePk.indexOf("?") < 0 && valuePk.indexOf("*") < 0) {
								sFilter += " field['" + sFieldName + "'] == '" + valuePk + "'";
							} else {
								sFilter += " field['" + sFieldName + "'] ~~ '" + valuePk + "'";
							}
						}
						sFilter += ")";
					}

				} else {
					if (nameP.equals(TAGS._class)) {
						sClass = valueP;
						if (sClass.length() == 0)
							sClass = "*";
					} else if (nameP.equals(TAGS._name)) {
						sName = valueP;
						if (sName.length() == 0)
							sName = "*";
					} else if (nameP.equals(TAGS._revision)) {
						sRevision = valueP;
					} else if (nameP.equals(TAGS._lifecycle)) {
						sLifecycle = valueP;
						if (sLifecycle.length() == 0)
							sLifecycle = "*";
					} else if (nameP.equals(TAGS._objectspace)) {
						sObjectSpace = valueP;
						if (sObjectSpace.length() == 0)
							sObjectSpace = "*";
					} else if (nameP.equals(TAGS._description)) {
						sDescription = valueP;
					} else if (nameP.equals(TAGS._holder)) {
						sHolder = valueP;
						if (sHolder.length() == 0)
							sHolder = "*";
					} else if (nameP.equals(TAGS._locker)) {
						sLocker = valueP;
						if (sLocker.length() == 0)
							sLocker = "*";
					} else if (nameP.equals(TAGS._currentstage)) {
						sStage = valueP;
						if (sStage.length() == 0)
							sStage = "*";
					} else if (nameP.equals(TAGS._origdate) && valueP.length() > 0) {
						Item item = form.getItemField(TAGS.origdate);
						if (item != null && (item.getFieldType() == Item.FIELDTYPE_DATE || item.getFieldType() == Item.FIELDTYPE_TEXT)) {
							valueP = StringUtils.unformatValue(valueP, item.getFormat(), locale);
						}
						sOperator = request.getParameter(TAGS.operator + nameP);
						if (sOperator == null) {
							sOperator = "==";
						}
						if (sOperator.length() > 0) {
							if (!sFilter.equals("")) {
								sFilter += " &&";
							}
							sFilter += " origdate " + sOperator + " '" + valueP + "'";
						}
						sOperator = request.getParameter(TAGS.operator + nameP + TAGS._2);
						if (sOperator != null && sOperator.length() > 0) {
							if (!sFilter.equals("")) {
								sFilter += " &&";
							}
							valueP = request.getParameter(nameP + TAGS._2);
							if (item != null && (item.getFieldType() == Item.FIELDTYPE_DATE || item.getFieldType() == Item.FIELDTYPE_TEXT)) {
								valueP = StringUtils.unformatValue(valueP, item.getFormat(), locale);
							}
							sFilter += " origdate " + sOperator + " '" + valueP + "'";
						}
					} else if (nameP.equals(TAGS._moddate) && valueP.length() > 0) {
						Item item = form.getItemField(TAGS.moddate);
						if (item != null && (item.getFieldType() == Item.FIELDTYPE_DATE || item.getFieldType() == Item.FIELDTYPE_TEXT)) {
							valueP = StringUtils.unformatValue(valueP, item.getFormat(), locale);
						}
						sOperator = request.getParameter(TAGS.operator + nameP);
						if (sOperator == null) {
							sOperator = "==";
						}
						if (sOperator.length() > 0) {
							if (!sFilter.equals("")) {
								sFilter += " &&";
							}
							sFilter += " moddate " + sOperator + " '" + valueP + "'";
						}
						sOperator = request.getParameter(TAGS.operator + nameP + TAGS._2);
						if (sOperator != null && sOperator.length() > 0) {
							if (!sFilter.equals("")) {
								sFilter += " &&";
							}
							valueP = request.getParameter(nameP + TAGS._2);
							if (item != null && (item.getFieldType() == Item.FIELDTYPE_DATE || item.getFieldType() == Item.FIELDTYPE_TEXT)) {
								valueP = StringUtils.unformatValue(valueP, item.getFormat(), locale);
							}
							sFilter += " moddate " + sOperator + " '" + valueP + "'";
						}
					} else if (nameP.equals(TAGS.filter) && valueP.length() > 0) {
						try {
							framework.setEnvFromRequest(request, false);
							Program filterprog = Program.open(valueP,framework,null);
							framework.clearResult();
							Vector<Object> vArgs = new Vector<Object>(0);
							vArgs.add(form.getName());
							filterprog.execute(framework,vArgs);
							String sExtraFilter = framework.getResult().trim();
							if (sExtraFilter.length() > 0) {
								if (!sFilter.equals("")) {
									sFilter += " && ";
								}
								sFilter += sExtraFilter;
							}
						} catch (Exception e) {
						}
					}
				}
			}

			Query query = new Query();
			query.addClassPattern(sClass);
			query.addNamePattern(sName);
			query.addRevisionPattern(sRevision);
			if (!sLifecycle.equals("*")) {
				query.addLifecyclePattern(sLifecycle);
			}
			if (!sDescription.equals("*")) {
				query.setDescriptionPattern(sDescription);
			}
			if (!sHolder.equals("*")) {
				query.addHolderPattern(sHolder);
			}
			if (!sStage.equals("*")) {
				query.addStagePattern(sStage);
			}
			if (!sObjectSpace.equals("*")) {
				query.addObjectSpacePattern(sObjectSpace);
			}
			if (!sFilter.equals("")) {
				query.setFilter(sFilter);
			}
			try { query.setMaxItems(Integer.parseInt(sLimit)); } catch (Exception ex) {}
			query.setSelector(new Selector(ObjectObj.class,"").addBasic("id").addSeparatorToken(Application.sToken));			
			//System.out.println(query.toString());
			if (bPreview) return "query immediate "+query.getExecuteCommand()+" maxitems "+query.getMaxItems()+";";
			session.setAttribute(TAGS.table + formHTMLName, new Vector<String[]>(0));
			framework.clearResult();
			try {
				query.execute(null,framework);
				Vector<String> vResult = StringUtils.StringTokensToVector(framework.getResult().trim(),"\n");
				int iFoundObjects = vResult.size();
				if (iFoundObjects == Integer.parseInt(sLimit)) {
					String sCommonSection = getDictCommon(session);
					sReturn = TAGS.FORM_ActionAlert+("(\"")+Dictionary.getKey(sCommonSection,"MSG_LimitReached",framework)+" ["+sLimit+"]\");";
				}
				Vector<String[]> vObjects = new Vector<String[]>(iFoundObjects);
				for (int i=0;i<iFoundObjects;i++) {
					vObjects.add( StringUtils.StringTokensToArray(vResult.elementAt(i),Application.sToken));
				}
				session.setAttribute(TAGS.table + formHTMLName, vObjects);
			} catch (Exception e) {
				return e.getMessage();
			}
		}
		return sReturn;
	}

	public static Vector<Object> getSearchResults(String formHTMLName, HttpSession session) throws Exception {
		return (Vector<Object>) session.getAttribute(TAGS.table + formHTMLName);
	}

	public static void clearSearchResults(String formHTMLName, HttpSession session) throws Exception {
		session.removeAttribute(TAGS.table + formHTMLName);
	}

	public static View applyView(String sView, String formHTMLName, HttpSession session) throws Exception {
		Framework framework = Application.getFramework(session);
		View view = View.open(sView,framework.getUserName(),framework);
		String sStoredView = (String) session.getAttribute(TAGS.view);
		if ( sStoredView==null || !sStoredView.equals(sView) ) {	
			Vector<Object> vObjects = getSearchResults(formHTMLName,session);
			int iFoundObjects = vObjects.size();
			if (iFoundObjects>0) {
				try {
					Vector<ViewUserColumn> vColumnWithData = view.getUserColumnsWithData(vObjects,null,framework);
					session.setAttribute(TAGS.view_data+formHTMLName,vColumnWithData);
				} catch (Exception e) {
					setErrorMessage(session,StringUtils.replaceString(e.getMessage(),"\n","<br>"));					
				}
			}
			session.setAttribute(TAGS.view,sView);
		}
		return view;
	}
	
	public static Vector<Object> getViewData(String formHTMLName, HttpSession session) throws Exception {
		return (Vector<Object>) session.getAttribute(TAGS.view_data+ formHTMLName);
	}
	
%><%
    number_separator_symbols = getAppParam(TAGS.APP_number_separator_symbols);
	use_search_patterns = getAppParam(TAGS.APP_use_search_patterns).equalsIgnoreCase("true");
%>