/*
 * If the date is not set, make it the clients PC date!
 */
if(typeof(iMonth)=="undefined")
	iMonth = new Date().getMonth();
if(typeof(iYear)=="undefined")
	iYear = new Date().getFullYear();
if(typeof(iDay)=="undefined")
	iDay = new Date().getDate();
if(typeof(itype) == "undefined")
	itype = "loose"; //loose->any date|strict->limit to maxDays
if(typeof(imaxDays) == "undefined")
	imaxDays = 330; //counts only if itype=strict. Enable selection imaxDays from start date
if(typeof(stDay) == "undefined")
	startDay = iDay; //enable selection from this date
if(typeof(stMonth) == "undefined")
	startMonth = iMonth;
if(typeof(stYear) == "undefined")
	startYear = iYear;
if(typeof(offX) == "undefined")
	offX = 10; // x distance from the mouse.
if(typeof(offY) == "undefined")
	offY = -10; // y distance from the mouse.
if(typeof(formatInputs) == "undefined")
	formatInputs = 1; // Gather the data from no. of inputs
if(typeof(formatSplitter) == "undefined")
	formatSplitter = "-"; // Character to add betwen day/month/year
if(typeof(dayFormat) == "undefined")
	dayFormat = "dd";
if(typeof(monthFormat) == "undefined")
	monthFormat = "MM";
if(typeof(yearFormat) == "undefined")
	yearFormat = "yyyy";
if(typeof(folowMouse) == "undefined")
	folowMouse = true;
if(typeof(formatType) == "undefined")
	formatType = yearFormat+formatSplitter+monthFormat+formatSplitter+dayFormat; //Format data type
if(typeof(callNotice) == "undefined")
	callNotice = "fallsilent()"; //call another function that a date has been selected.


if (window.addEventListener)
	window.addEventListener("load", createBase, false);
else if (window.attachEvent)
	window.attachEvent("onload", createBase);
else if (document.getElementById)
	window.onload=createBase;

document.onmousemove = getMouseXY;
var IE = document.all?true:false;
if (!IE) document.captureEvents(Event.MOUSEMOVE);

var tempX = 0;
var tempY = 0;

function getMouseXY(e) {
  if (IE) { // grab the x-y pos.s if browser is IE
    tempX = event.clientX + document.body.scrollLeft;
    tempY = event.clientY + document.body.scrollTop;
  } else {  // grab the x-y pos.s if browser is NS
    tempX = e.pageX;
    tempY = e.pageY;
  }
  if (tempX < 0){tempX = 0;}
  if (tempY < 0){tempY = 0;}

  return true;
}

function keyHandler(e) { 
	var Key; 
	if (!IE) { Key = e.keyCode; } 
	else {Key = window.event.keyCode;} 	
	if(Key == 27) {
		closeCalendar();
    }
} 
// register handler 
document.onkeydown = keyHandler; 


function getScrollXY() {
  var scrOfX = 0, scrOfY = 0;
  if( typeof( window.pageYOffset ) == 'number' ) {
    //Netscape compliant
    scrOfY = window.pageYOffset;
    scrOfX = window.pageXOffset;
  } else if( document.body && ( document.body.scrollLeft || document.body.scrollTop ) ) {
    //DOM compliant
    scrOfY = document.body.scrollTop;
    scrOfX = document.body.scrollLeft;
  } else if( document.documentElement && ( document.documentElement.scrollLeft || document.documentElement.scrollTop ) ) {
    //IE6 standards compliant mode
    scrOfY = document.documentElement.scrollTop;
    scrOfX = document.documentElement.scrollLeft;
  }
  return [ scrOfX, scrOfY ];
}



/*
 * Shortcut functions to ease the implementation.
 */

function cel(obj){ return document.createElement(obj);  }
function sa(obj, atname, atprop){ return  obj.setAttribute(atname, atprop);  }
function appendc(obj, elem){ return  obj.appendChild(elem); }
function cNode(obj, txt){ return obj.appendChild(document.createTextNode(txt)); }
function getID(elem){ return document.getElementById(elem); }


var TodayText ="Today";
var CloseText ="Close";
var ResetText ="Reset";
var DayCol = new Array("" , "M", "T", "W", "T", "F", "S", "S" );
var MonthCol = new Array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov", "Dec");
var date_language = "" ; 

function getDaysInMonth(mnt, yr)
{
	var DaysInMonth = new Array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
	if (mnt == 1)
	  DaysInMonth[1] = ((yr % 400 == 0) || ((yr % 4 == 0) && (yr % 100 !=0))) ? 29 : 28;
	return DaysInMonth[mnt];
}
/*
 * Base class for the widget
 */

var cw = {
	currMonth: iMonth,
	currYear: iYear,
	currDay: iDay,
	selMonth: iMonth,
	selYear: iYear,
	selDay: iDay,
	config: itype,
	maxDays: imaxDays,
	stMonth : startMonth,
	stYear : startYear,
	stDay : startDay,
	endMonth : 11,
	endYear : iYear,
	endDay : 31,
	setMarks: function()
	{
		if(this.config=='strict')
		{
			this.stDay = iDay;
			this.stMonth = iMonth;
			this.stYear = iYear;
			this.getEnd();
		}
	},
	getConfMonths: function()
	{
		if(this.config=='strict')
			cw.setMarks();
		mthCol = cel("ul");
		mthCol.id = "months";
		k=0;
		  for(var i=0;i<12; i++)
		  {
				mth = cel("li");
				if(cw.isValidMonth(i))
				{
					mth.className = "months";
					if(cw.isCurrentMonth(i))
						mth.className = "currMonth";
					mtha = cel("a");
					mtha.href = "javascript:modMonth("+this.selYear+"," + i + ")";
					mtha.innerHTML = MonthCol[i];
					appendc(mth, mtha);
				}
				else
				{
					mth.className = "monthDisabled";
					mth.innerHTML = MonthCol[i];
				}
				appendc(mthCol, mth);

		  }
		cw.setBrowseYears();

		return mthCol ;
	},
	getConfDays: function()
	{
		dayCol = cel("ul");
		dayCol.id = "days";
		for(var i=0;i<8;i++)
		{
			dayCell = cel("li");
			dayCell.className = "headDay";
			dayCell.innerHTML = DayCol[i];
			appendc(dayCol, dayCell);
		}
		var iNumWeek = new Date(this.selYear, this.selMonth, 1).getWeek();
		{
			dayWeek = cel('li');
			dayWeek.className = "dayWeek";
			dayWeek.innerHTML = iNumWeek;
			appendc(dayCol, dayWeek);
		}
		var iFirstDay = new Date(this.selYear, this.selMonth, 1).getDay();

		if(iFirstDay<1) { iFirstDay=7; }
		for(i=1;i<iFirstDay;i++)
		{
			dayCell = cel('li');
			dayCell.className = "dayBlank";
			dayCell.innerHTML = "&nbsp;";
			appendc(dayCol, dayCell);
		}

		for(i=1;i<=getDaysInMonth(this.selMonth, this.selYear); i++)
		{
			if (iFirstDay==8) {
				iFirstDay=1;
				iNumWeek = new Date(this.selYear, this.selMonth, i).getWeek();
			    dayCell = cel('li');
				dayCell.className = "dayWeek";
				dayCell.innerHTML = iNumWeek;
			    appendc(dayCol, dayCell);
			}
			dayCell = cel('li');
			if(cw.isValidDate(i))
			{
				dayCell.className = "dayNormal";
				if(cw.isWeekend(i))
					dayCell.className = "dayWeekend";
				if(cw.isCurrentDay(i))
					dayCell.className = "dayCurrent";
				dayLink = cel('a');
				dayLink.href="javascript: newDay("+ i + ");fillBackDate("+i+","+this.selMonth+","+ this.selYear+")";
				dayLink.innerHTML = i;
				appendc(dayCell, dayLink);
			}
			else
			{
				dayCell.className = "dayDisabled";
				dayCell.innerHTML = i;
			}
			appendc(dayCol, dayCell);
			iFirstDay++;
		}
		return dayCol;
	},
	getEnd: function()
	{
		imaxD = imaxDays - (getDaysInMonth(this.stMonth, this.stYear) - this.stDay);
		tmpM = this.stMonth;
		tmpY = this.stYear;
		tmpD = this.stDay;
		i=0;
		while(imaxD >= getDaysInMonth(tmpM, tmpY))
		{
			tmpM++;
			if(tmpM>11)
			{
				tmpM=0;
				tmpY++;
			}
			tmpD = imaxD -= getDaysInMonth(tmpM, tmpY);
		}
		tmpM++;
		if(tmpM>11){tmpM=0; tmpY++;}
		this.endMonth = tmpM;
		this.endDay = tmpD;
		this.endYear = tmpY;
	},
	isValidDate: function(tDay)
	{
		if(this.config == "loose")
			return true;
		if(this.selYear==this.stYear)
		{
			if(this.selMonth<this.stMonth)
				return false;
			if(this.selMonth==this.stMonth && tDay <this.stDay)
				return false;
		}
		if(this.selYear==this.endYear)
		{
			if(this.selMonth>this.endMonth)
				return false;
			if(this.selMonth==this.endMonth && tDay>this.endDay)
				return false;

		}
		if(this.selYear == this.endYear && this.selYear==this.stYear){
			if(this.selMonth> this.endMonth || this.selMonth<this.stMonth)
				return false;
			}
		if(this.selYear>this.endYear)
			return false;
		return true;

	},
	isWeekend: function(tDay)
	{
		sun = new Date(this.selYear, this.selMonth, tDay).getDay();
		if(sun==6||sun==0)
			return true;
		return false;
	},
	isCurrentDay: function(tDay)
	{
		if(this.selDay == tDay)
			return true;
		return false;
	},
	setBrowseYears: function()
	{
		brsY = cel('li');
		brsY.className = "yearBrowse";
		if(this.selYear <= this.stYear && this.config == "strict")
		{
			backB = cel('span');
		}
		else
		{
			backB= cel('a');
			backB.href = "javascript: modYear(-1)";
		}
		backB.innerHTML = "&laquo;";
		yText = cel("b");
		yText.innerHTML = cw.selYear;
		if(this.selYear >= this.endYear && this.config == "strict")
			fwdB = cel('span');
		else
		{
			fwdB = cel('a');
			fwdB.href= "javascript: modYear(1)";
		}
		fwdB.innerHTML = "&raquo;";
		appendc(brsY, backB);
		appendc(brsY, yText);
		appendc(brsY, fwdB);
		appendc(mthCol, brsY);
	},
	isValidMonth: function(m)
	{
		if(this.config == "loose")
			return true;
		else
		{
			if(this.selYear< this.stYear)
				return false;
			if(this.selYear==this.stYear && m<this.stMonth)
				return false;
			if(this.selYear>this.endYear)
				return false;
			if(this.selYear==this.endYear && m>this.endMonth)
				return false;
		}
		return true;
	},
	isCurrentMonth: function(i)
	{
		if(i==this.selMonth)
			return true;
		return false;
	}
};

cw.setMarks();
function createBase()
{
	var el = cel('div');
	el.id="calendar";
	el.style.display="none";
	if(typeof(elToAppend) == "undefined")
		tDocument = document.getElementsByTagName('body').item(0);
	else
	{
		var tt = elToAppend;
		tDocument = document.getElementById(tt);
	}
	appendc(tDocument, el);
}


function createCalendarElements()
{
	var el = 'calendar';
	var calCon = cel('div');
	calCon.id = "elements";
	while(document.getElementById(el).firstChild)
		document.getElementById(el).removeChild(document.getElementById(el).firstChild);
	appendc(document.getElementById(el), calCon);
	mthCol = cw.getConfMonths();
	appendc(calCon, mthCol);
	dayStruct = cw.getConfDays();
	appendc(calCon, dayStruct);

	divBtn = cel('div');
	divBtn.id = "divBtn";

	todayBtna = cel('a');
	todayBtna.href = "javascript: setToday()";
	todayBtna.innerHTML = TodayText;
	appendc(divBtn, todayBtna);

	cNode(divBtn, "  -  ");

	resetBtna = cel('a');
	resetBtna.href = "javascript: resetDate()";
	resetBtna.innerHTML = ResetText;
	appendc(divBtn, resetBtna);

	cNode(divBtn, "  -  ");

	closeBtna = cel('a');
	closeBtna.href = "javascript: closeCalendar()";
	closeBtna.innerHTML = CloseText;
	appendc(divBtn, closeBtna);

	appendc(document.getElementById(el), divBtn);
}
function modMonth(newY, newM)
{
	cw.selYear = newY;
	cw.selMonth = newM;
	createCalendarElements();
}
function newDay(newD)
{
	cw.selDay = newD;
	createCalendarElements();
}
function modYear(way)
{
	cw.selYear = parseInt(cw.selYear) + parseInt(way);
	createCalendarElements();
}
var datas;
var elem1;
var elem2;
var elem3;
var dA=0;
var mA=0;
var yA=0;
var dd = new Array('d', 'dd');
var mm = new Array('M', 'MM', 'MMM');
var yy = new Array('yy', 'yyyy');


function parseDate(dateString,formatDate,language) {
	if (formatDate!="") {
		formatType=formatDate;
		for (var i = 0; i < formatDate.length; i++) {
		   if ( "mMdDyY".indexOf( formatDate.charAt(i) ) < 0 ) {
			   formatSplitter=formatDate.charAt(i);
			   break;
		   }
	    }
	}	
    if ( date_language == "" ) { setLanguage(language); }
	datas = dateString.split(formatSplitter);
	tmpo = formatType.split(formatSplitter);
		
	if(datas.length == tmpo.length)	{
		dC="";tC="";	
		for(i=0;i<datas.length;i++) {
			if(datas[i].length<2)
				datas[i] = "0"+datas[i];
			dC +=datas[i];
			tC +=tmpo[i];
		}
		orderData();
	} else {
		datas = new Array(cw.selDay, cw.selMonth, cw.selYear);
	}
    return  new Date(cw.selYear, cw.selMonth, cw.selDay);
}

function formatDate(dateString,formatDate,language) {
    var date = parseDate(dateString,"yyyy-MM-dd",language);
	order = new String(formatDate).split(formatSplitter);	
	for(var j=0;j<order.length;j++)	{
		for(var i=0;i<dd.length;i++) {	
		  if(dd[i] == order[j])	dA = i;
		}
		for(i=0;i<mm.length;i++) {	
		  if(mm[i] == order[j]) mA = i;
		}
		for(i=0;i<yy.length;i++) {	
		  if(yy[i] == order[j])	yA = i;
		}
	}	
	var tYear  = date.getFullYear();
	var tMonth = date.getMonth();
	var tDay   = date.getDate();
	if(mA==2)
		tMonth = MonthCol[tMonth];
	if(mA==1 || mA==0)
	{
		tMonth++;
		if(mA==1 && tMonth<10)
			tMonth = "0"+tMonth;
	}
	if(yA==0)
		tYear = new String(tYear).slice(2,4);
	
	if(tDay<10 && dA==1)
	{
		tDay = "0"+tDay;
	}	
	
	var sdata = "";
	for(j=0;j<order.length;j++)	{
		if (j>0) { sdata+=formatSplitter; }
		if(dd[dA] == order[j]) { sdata+=tDay; }
		if(mm[mA] == order[j]) { sdata+=tMonth; }
		if(yy[yA] == order[j]) { sdata+=tYear; }			
	}
	return sdata;		
}

function showCalendar(language,formatDate,param1, param2, param3)
{
	if (formatDate!="") {
		formatType=formatDate;
		for (var i = 0; i < formatDate.length; i++) {
		   if ( "mMdDyY".indexOf( formatDate.charAt(i) ) < 0 ) {
			   formatSplitter=formatDate.charAt(i);
			   break;
		   }
	    }
	}
	
	tmpString = new String();
	if(formatInputs==1)
	{
		elem1 = param1;
		tmpString = document.getElementById(elem1).value;
	}
	if(formatInputs==2)
	{
		elem1 = param1;
		elem2 = param2;
		tmpString = document.getElementById(elem1).value + formatSplitter + document.getElementById(elem2).value;
	}
	if(formatInputs==3)
	{
		elem1 = param1;
		elem2 = param2;
		elem3 = param3;
		tmpString = document.getElementById(elem1).value + formatSplitter +
					document.getElementById(elem2).value + formatSplitter +
					document.getElementById(elem3).value;
	}
	
	parseDate(tmpString,formatDate,language);	
	createCalendarElements();
	offsets = getScrollXY();
	document.getElementById('calendar').style.display = "block";

	if(folowMouse) {
		var browser=navigator.appName;
		if(browser=="Microsoft Internet Explorer")
		{
			document.getElementById('calendar').style.left = parseInt(tempX)+parseInt(offX)+parseInt(offsets[0]) + 'px';
		    document.getElementById('calendar').style.top = parseInt(tempY)+parseInt(offY)+parseInt(offsets[1]) + 'px';
		}
		else
		{
			document.getElementById('calendar').style.left = parseInt(tempX)+parseInt(offX)+ 'px';
		    document.getElementById('calendar').style.top = parseInt(tempY)+parseInt(offY)+ 'px';
		}
	}
	order = new String(formatType).split(formatSplitter);	
	for(var j=0;j<order.length;j++)	{
		for(i=0;i<dd.length;i++) {	
		  if(dd[i] == order[j])	dA = i;
		}
		for(i=0;i<mm.length;i++) {	
		  if(mm[i] == order[j]) mA = i;
		}
		for(i=0;i<yy.length;i++) {	
		  if(yy[i] == order[j])	yA = i;
		}
	}
}

function orderData() {
	order = new String(formatType).split(formatSplitter);
	for(var i=0;i<order.length;i++)
	{
		for(var j=0;j<mm.length;j++)
		{
			if(mm[j] == order[i])
			{
				cw.selMonth = datas[i];
				if(cw.selMonth.slice(0, 1) == 0)
					cw.selMonth = parseInt(cw.selMonth.slice(1, cw.selMonth.length))-1;
				else if(cw.selMonth.length<3)
					cw.selMonth = parseInt(cw.selMonth)-1;
			
				if(j==2)
				{
					for(var k=0;k<MonthCol.length;k++)
					{  
						if(MonthCol[k].toLowerCase() == cw.selMonth.toLowerCase() )
						{
							cw.selMonth = k;
							break;
						}
					}
				}
			}
			if(yy[j] == order[i])
			{
				cw.selYear = datas[i];
				if(cw.selYear.slice(0, 1) == 0)
					cw.selYear = parseInt(cw.selYear.slice(1, cw.selYear.length));
				if(j==0)
					cw.selYear =2000 + parseInt(cw.selYear);
			}
		}
		if(order[i].toLowerCase() == 'dd')
		{
			cw.selDay = datas[i];
			if(cw.selDay.slice(0, 1) == 0)
				cw.selDay = parseInt(cw.selDay.slice(1, cw.selDay.length));
		} else if(order[i].toLowerCase() == 'd') {
			cw.selDay = datas[i];
		}
	}
	
	if ( cw.selYear<2000 ) { cw.selYear=2000; }
	if ( cw.selYear>3000 ) { cw.selYear=3000; }
	if ( cw.selMonth<0 )   { cw.selMonth=0; }
	if ( cw.selMonth>11 )  { cw.selMonth=11; }
	if ( cw.selDay>31 )    { cw.selDay=1; }
	if ( cw.selDay<1 )     { cw.selDay=1; }
}

function fillBackDate(tDay, tMonth, tYear)
{
	if(mA==2)
		tMonth = MonthCol[tMonth];
	if(mA==1 || mA==0)
	{
		tMonth++;
		if(mA==1 && tMonth<10)
			tMonth = "0"+tMonth;
	}
	if(yA==0)
		tYear = new String(tYear).slice(2,4);
	
	if(tDay<10 && dA==1)
	{
		tDay = "0"+tDay;
	}
	
	if(formatInputs==1)
	{
		var sdata = "";
		for(var j=0;j<order.length;j++)	{
			if (j>0) { sdata+=formatSplitter; }
			if(dd[dA] == order[j]) { sdata+=tDay; }
			if(mm[mA] == order[j]) { sdata+=tMonth; }
			if(yy[yA] == order[j]) { sdata+=tYear; }			
		}
		document.getElementById(elem1).value =sdata ;
	}
	if(formatInputs==2)
	{
		document.getElementById(elem1).value = tYear;
		document.getElementById(elem2).value = tMonth + formatSplitter + tDay;
	}
	if(formatInputs==3)
	{
		document.getElementById(elem1).value = tYear;
		document.getElementById(elem2).value = tMonth;
		document.getElementById(elem3).value = tDay;
	}
	setTimeout(callNotice, 0);

	closeCalendar();
}

function closeCalendar()
{
	var el = 'calendar';
	document.getElementById(el).style.display = "none";
}

function setToday()
{
	var todayDate=new Date();
    fillBackDate(todayDate.getDate(), todayDate.getMonth(), todayDate.getFullYear());
}

function resetDate()
{
	if(formatInputs==1)
	{
		document.getElementById(elem1).value = "";
	}
	if(formatInputs==2)
	{
		document.getElementById(elem1).value = "";
		document.getElementById(elem2).value = "";
	}
	if(formatInputs==3)
	{
		document.getElementById(elem1).value = "";
		document.getElementById(elem2).value = "";
		document.getElementById(elem3).value = "";
	}

	closeCalendar();
}


function fallsilent(){}

function setLanguage(lang){

   date_language = lang;
   TodayText ="Today";
   CloseText ="Close";
   ResetText ="Reset";
   var Months = new Array('January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December');
   var Days = new Array("" , 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat','Sun');

   if (lang=="FR") {
   TodayText ="Aujourd'hui";
   CloseText ="Close";
    Months = new Array('Janvier', 'Fvrier', 'Mars', 'Avril', 'Mai', 'Juin', 'Juillet', 'Aot', 'Septembre', 'Octobre', 'Novembre', 'Dcembre');
    Days = new Array("" , 'Lun', 'Mar', 'Mer', 'Jeu', 'Ven', 'Sam','Dim');

   } else if (lang=="DE") {
   TodayText ="Heute";
    Months = new Array('Januar', 'Februar', 'Marz', 'April', 'Mai', 'Juni', 'Juli', 'August', 'September', 'Oktober', 'November', 'Dezember');
    Days = new Array("" , 'Mon', 'Die', 'Mit', 'Don', 'Fre', 'Sam','Son');

   } else if (lang=="NL") {
   TodayText ="Vandaag";
    Months = new Array('Januari', 'Februari', 'Maart', 'April', 'Mei', 'Juni', 'Juli', 'Augustus', 'September', 'Oktober', 'November', 'December');
    Days = new Array("", 'Ma', 'Di', 'Wo', 'Do', 'Vr', 'Za' ,'Zo');

   } else if (lang=="IT") {
    TodayText ="Oggi";
    ResetText ="Cancella";
    CloseText ="Chiudi";
     Months = new Array('Gennaio', 'Febbraio', 'Marzo', 'Aprile', 'Maggio', 'Giugno', 'Luglio', 'Agosto', 'Settembre', 'Ottobre', 'Novembre', 'Dicembre');
     Days = new Array("" , 'Lun', 'Mar', 'Mer', 'Gio', 'Ven', 'Sab','Dom');

   } else if (lang=="PL") {
   TodayText ="Dzisiaj";
    Months = new Array('Stycze?', 'Luty', 'Marzec', 'Kwiecie?', 'Maj', 'Czerwiec', 'Lipiec', 'Sierpie?', 'Wrzesie?', 'Pa?dziernik', 'Listopad', 'Grudzie?');
    Days = new Array("" , 'Pon', 'Wto', '?ro', 'Czw', 'Pi?', 'Sob','Nie');

   } else if (lang=="RO") {
   TodayText ="Astazi";
    Months = new Array('Ianuarie', 'Februarie', 'Martie', 'Aprilie', 'Mai', 'Iunie', 'Iulie', 'August', 'Septembrie', 'Octombrie', 'Noiembrie', 'Decembrie');
    Days = new Array("" , 'Lun', 'Mar', 'Mie', 'Joi', 'Vin', 'Sam','Dum');

   } else if (lang=="NO") {
   TodayText ="Dagens dato";
    Months = new Array('Januar','Februar', 'Mars', 'April', 'Mai', 'Juni', 'Juli', 'August', 'September', 'Oktober', 'November', 'Desember');
    Days = new Array("" , 'Man', 'Tir','Ons', 'Tor', 'Fre', 'Lr','Sn');

   } else if (lang=="HU") {
   TodayText ="Ma";
    Months = new Array('Janur', 'Februr', 'Mrcius', 'prilis', 'Mjus', 'Jnius', 'Jlius', 'Augusztus', 'Szeptember', 'Oktber', 'November', 'December');
    Days = new Array("" , 'H', 'Ke', 'Sze', 'Cs', 'P', 'Szo','Vas');

   } else if (lang=="PT") {
   TodayText ="Hoje";
    Months = new Array('Janeiro', 'Fevereiro', 'Maro', 'Abril', 'Maio', 'Junho', 'Julho', 'Agosto', 'Setembro', 'Outubro', 'Novembroe', 'Dezembro');
    Days = new Array("" , 'Seg', 'Ter', 'Qua', 'Qui', 'Sex', 'Sab','Dom');

   } else if (lang=="SV") {
   TodayText ="Idag";
    Months = new Array('Januari', 'Februari', 'Mars', 'April', 'Maj', 'Juni', 'Juli', 'Augusti', 'September', 'Oktober', 'November', 'December');
    Days = new Array("" , 'Mn', 'Tis', 'Ons', 'Tor', 'Fre', 'Lr','Sn');

   } else if (lang=="CZ") {
   TodayText ="Dnes";
    Months = new Array('Leden', 'nor', 'Brezen', 'Duben', 'Kveten', 'Cerven', 'Cervenec', 'Srpen', 'Zr', 'Rjen', 'Listopad', 'Prosinec');
    Days = new Array("" , 'Po', 't', 'St', 'Ct', 'P', 'So','Ne');
   }

    for(var i=0;i<MonthCol.length;i++)	{
	   MonthCol[i]=Months[i].substring(0,3);
	}

	for(i=1;i<DayCol.length;i++)	{
		   DayCol[i]=Days[i].substring(0,2);
	}

}



// function added by slavic (thank you Internet!)
function isLeapYear(yr) {
  return new Date(yr,2-1,29).getDate()==29;
}

Date.prototype.getWeek = function () {
	/*getWeek() was developed by Nick Baicoianu at MeanFreePath: http://www.meanfreepath.com */

	var newYear = new Date(this.getFullYear(),0,1);
	var day = newYear.getDay() - 1; //the day of week the year begins on
	day = (day >= 0 ? day : day + 7);
	var daynum = Math.floor((this.getTime()-newYear.getTime() - (this.getTimezoneOffset()-newYear.getTimezoneOffset())*60000)/86400000) + 1;
	var weeknum;
	//if the year starts before the middle of a week
	if(day < 4)
	{
		weeknum = Math.floor((daynum+day-1)/7) + 1;
		if(weeknum > 52)
		{
			nYear = new Date(this.getFullYear() + 1,0,1);
			nday = nYear.getDay() - 1;
			nday = nday >= 0 ? nday : nday + 7;
			/*if the next year starts before the middle of
			the week, it is week #1 of that year*/
			weeknum = nday < 4 ? 1 : 53;
		}
	}
	else
	{
		weeknum = Math.floor((daynum+day -1 )/7);
		if(weeknum == 0)
		{
			prevYear = new Date(this.getFullYear()-1,0,1);
			prevDay = prevYear.getDay()-1;
			prevDay = (prevDay >= 0 ? prevDay : prevDay + 7);
			if( prevDay==3 || ( isLeapYear(prevYear.getFullYear()) && prevDay==2 ) )
			{ weeknum = 53; }
				else weeknum = 52;
		}
	}
	return weeknum;
};



